/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * RISCV Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * Have a static const max_size_in_bits equal to the number of bits in the
//   encoding.
// * be default-constructible and copy-constructible
// * be constructible from a uint64_t
// * be constructible from an APInt (this can be private)
// * Support getBitsSet(loBit, hiBit)
// * be convertible to uint64_t
// * Support the ~, &, ==, !=, and |= operators with other objects of the same type
// * Support shift (<<, >>) with signed and unsigned integers on the RHS
// * Support put (<<) to raw_ostream&
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::true_type) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits, std::false_type) {
  assert(startBit + numBits <= InsnType::max_size_in_bits && "Instruction field out of bounds!");
  InsnType fieldMask = InsnType::getBitsSet(0, numBits);
  return (insn >> startBit) & fieldMask;
}

template<typename InsnType>
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
  return fieldFromInstruction(insn, startBit, numBits, std::is_integral<InsnType>());
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 3 */       MCD::OPC_FilterValue, 0, 132, 0, 0, // Skip to: 140
/* 8 */       MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 11 */      MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 41
/* 16 */      MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 32
/* 21 */      MCD::OPC_CheckField, 2, 11, 0, 4, 0, 0, // Skip to: 32
/* 28 */      MCD::OPC_Decode, 158, 3, 0, // Opcode: C_UNIMP
/* 32 */      MCD::OPC_CheckPredicate, 0, 24, 3, 0, // Skip to: 829
/* 37 */      MCD::OPC_Decode, 234, 2, 1, // Opcode: C_ADDI4SPN
/* 41 */      MCD::OPC_FilterValue, 1, 41, 0, 0, // Skip to: 87
/* 46 */      MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 62
/* 51 */      MCD::OPC_CheckField, 2, 11, 0, 4, 0, 0, // Skip to: 62
/* 58 */      MCD::OPC_Decode, 141, 3, 0, // Opcode: C_NOP
/* 62 */      MCD::OPC_CheckPredicate, 1, 11, 0, 0, // Skip to: 78
/* 67 */      MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 78
/* 74 */      MCD::OPC_Decode, 142, 3, 2, // Opcode: C_NOP_HINT
/* 78 */      MCD::OPC_CheckPredicate, 0, 234, 2, 0, // Skip to: 829
/* 83 */      MCD::OPC_Decode, 232, 2, 3, // Opcode: C_ADDI
/* 87 */      MCD::OPC_FilterValue, 2, 225, 2, 0, // Skip to: 829
/* 92 */      MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 115
/* 97 */      MCD::OPC_CheckField, 12, 1, 0, 11, 0, 0, // Skip to: 115
/* 104 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 115
/* 111 */     MCD::OPC_Decode, 148, 3, 4, // Opcode: C_SLLI64_HINT
/* 115 */     MCD::OPC_CheckPredicate, 1, 11, 0, 0, // Skip to: 131
/* 120 */     MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 131
/* 127 */     MCD::OPC_Decode, 149, 3, 5, // Opcode: C_SLLI_HINT
/* 131 */     MCD::OPC_CheckPredicate, 0, 181, 2, 0, // Skip to: 829
/* 136 */     MCD::OPC_Decode, 147, 3, 6, // Opcode: C_SLLI
/* 140 */     MCD::OPC_FilterValue, 1, 45, 0, 0, // Skip to: 190
/* 145 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 148 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 162
/* 153 */     MCD::OPC_CheckPredicate, 2, 159, 2, 0, // Skip to: 829
/* 158 */     MCD::OPC_Decode, 246, 2, 7, // Opcode: C_FLD
/* 162 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 176
/* 167 */     MCD::OPC_CheckPredicate, 3, 145, 2, 0, // Skip to: 829
/* 172 */     MCD::OPC_Decode, 235, 2, 3, // Opcode: C_ADDIW
/* 176 */     MCD::OPC_FilterValue, 2, 136, 2, 0, // Skip to: 829
/* 181 */     MCD::OPC_CheckPredicate, 2, 131, 2, 0, // Skip to: 829
/* 186 */     MCD::OPC_Decode, 247, 2, 8, // Opcode: C_FLDSP
/* 190 */     MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 256
/* 195 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 198 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 212
/* 203 */     MCD::OPC_CheckPredicate, 0, 109, 2, 0, // Skip to: 829
/* 208 */     MCD::OPC_Decode, 136, 3, 9, // Opcode: C_LW
/* 212 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 242
/* 217 */     MCD::OPC_CheckPredicate, 1, 11, 0, 0, // Skip to: 233
/* 222 */     MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 233
/* 229 */     MCD::OPC_Decode, 133, 3, 10, // Opcode: C_LI_HINT
/* 233 */     MCD::OPC_CheckPredicate, 0, 79, 2, 0, // Skip to: 829
/* 238 */     MCD::OPC_Decode, 132, 3, 11, // Opcode: C_LI
/* 242 */     MCD::OPC_FilterValue, 2, 70, 2, 0, // Skip to: 829
/* 247 */     MCD::OPC_CheckPredicate, 0, 65, 2, 0, // Skip to: 829
/* 252 */     MCD::OPC_Decode, 137, 3, 12, // Opcode: C_LWSP
/* 256 */     MCD::OPC_FilterValue, 3, 76, 0, 0, // Skip to: 337
/* 261 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 264 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 278
/* 269 */     MCD::OPC_CheckPredicate, 3, 43, 2, 0, // Skip to: 829
/* 274 */     MCD::OPC_Decode, 130, 3, 13, // Opcode: C_LD
/* 278 */     MCD::OPC_FilterValue, 1, 40, 0, 0, // Skip to: 323
/* 283 */     MCD::OPC_ExtractField, 7, 5,  // Inst{11-7} ...
/* 286 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 300
/* 291 */     MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 314
/* 296 */     MCD::OPC_Decode, 135, 3, 10, // Opcode: C_LUI_HINT
/* 300 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 314
/* 305 */     MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 314
/* 310 */     MCD::OPC_Decode, 233, 2, 14, // Opcode: C_ADDI16SP
/* 314 */     MCD::OPC_CheckPredicate, 0, 254, 1, 0, // Skip to: 829
/* 319 */     MCD::OPC_Decode, 134, 3, 15, // Opcode: C_LUI
/* 323 */     MCD::OPC_FilterValue, 2, 245, 1, 0, // Skip to: 829
/* 328 */     MCD::OPC_CheckPredicate, 3, 240, 1, 0, // Skip to: 829
/* 333 */     MCD::OPC_Decode, 131, 3, 16, // Opcode: C_LDSP
/* 337 */     MCD::OPC_FilterValue, 4, 81, 1, 0, // Skip to: 679
/* 342 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 345 */     MCD::OPC_FilterValue, 1, 213, 0, 0, // Skip to: 563
/* 350 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 353 */     MCD::OPC_FilterValue, 0, 32, 0, 0, // Skip to: 390
/* 358 */     MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 381
/* 363 */     MCD::OPC_CheckField, 12, 1, 0, 11, 0, 0, // Skip to: 381
/* 370 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 381
/* 377 */     MCD::OPC_Decode, 153, 3, 17, // Opcode: C_SRLI64_HINT
/* 381 */     MCD::OPC_CheckPredicate, 0, 187, 1, 0, // Skip to: 829
/* 386 */     MCD::OPC_Decode, 152, 3, 18, // Opcode: C_SRLI
/* 390 */     MCD::OPC_FilterValue, 1, 32, 0, 0, // Skip to: 427
/* 395 */     MCD::OPC_CheckPredicate, 1, 18, 0, 0, // Skip to: 418
/* 400 */     MCD::OPC_CheckField, 12, 1, 0, 11, 0, 0, // Skip to: 418
/* 407 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 418
/* 414 */     MCD::OPC_Decode, 151, 3, 17, // Opcode: C_SRAI64_HINT
/* 418 */     MCD::OPC_CheckPredicate, 0, 150, 1, 0, // Skip to: 829
/* 423 */     MCD::OPC_Decode, 150, 3, 18, // Opcode: C_SRAI
/* 427 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 441
/* 432 */     MCD::OPC_CheckPredicate, 0, 136, 1, 0, // Skip to: 829
/* 437 */     MCD::OPC_Decode, 242, 2, 19, // Opcode: C_ANDI
/* 441 */     MCD::OPC_FilterValue, 3, 127, 1, 0, // Skip to: 829
/* 446 */     MCD::OPC_ExtractField, 5, 2,  // Inst{6-5} ...
/* 449 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 485
/* 454 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 457 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 471
/* 462 */     MCD::OPC_CheckPredicate, 0, 106, 1, 0, // Skip to: 829
/* 467 */     MCD::OPC_Decode, 154, 3, 20, // Opcode: C_SUB
/* 471 */     MCD::OPC_FilterValue, 1, 97, 1, 0, // Skip to: 829
/* 476 */     MCD::OPC_CheckPredicate, 3, 92, 1, 0, // Skip to: 829
/* 481 */     MCD::OPC_Decode, 155, 3, 20, // Opcode: C_SUBW
/* 485 */     MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 521
/* 490 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 493 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 507
/* 498 */     MCD::OPC_CheckPredicate, 0, 70, 1, 0, // Skip to: 829
/* 503 */     MCD::OPC_Decode, 159, 3, 20, // Opcode: C_XOR
/* 507 */     MCD::OPC_FilterValue, 1, 61, 1, 0, // Skip to: 829
/* 512 */     MCD::OPC_CheckPredicate, 3, 56, 1, 0, // Skip to: 829
/* 517 */     MCD::OPC_Decode, 239, 2, 20, // Opcode: C_ADDW
/* 521 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 542
/* 526 */     MCD::OPC_CheckPredicate, 0, 42, 1, 0, // Skip to: 829
/* 531 */     MCD::OPC_CheckField, 12, 1, 0, 35, 1, 0, // Skip to: 829
/* 538 */     MCD::OPC_Decode, 144, 3, 20, // Opcode: C_OR
/* 542 */     MCD::OPC_FilterValue, 3, 26, 1, 0, // Skip to: 829
/* 547 */     MCD::OPC_CheckPredicate, 0, 21, 1, 0, // Skip to: 829
/* 552 */     MCD::OPC_CheckField, 12, 1, 0, 14, 1, 0, // Skip to: 829
/* 559 */     MCD::OPC_Decode, 241, 2, 20, // Opcode: C_AND
/* 563 */     MCD::OPC_FilterValue, 2, 5, 1, 0, // Skip to: 829
/* 568 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 571 */     MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 617
/* 576 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 592
/* 581 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 592
/* 588 */     MCD::OPC_Decode, 129, 3, 21, // Opcode: C_JR
/* 592 */     MCD::OPC_CheckPredicate, 1, 11, 0, 0, // Skip to: 608
/* 597 */     MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 608
/* 604 */     MCD::OPC_Decode, 139, 3, 22, // Opcode: C_MV_HINT
/* 608 */     MCD::OPC_CheckPredicate, 0, 216, 0, 0, // Skip to: 829
/* 613 */     MCD::OPC_Decode, 138, 3, 23, // Opcode: C_MV
/* 617 */     MCD::OPC_FilterValue, 1, 207, 0, 0, // Skip to: 829
/* 622 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 638
/* 627 */     MCD::OPC_CheckField, 2, 10, 0, 4, 0, 0, // Skip to: 638
/* 634 */     MCD::OPC_Decode, 245, 2, 0, // Opcode: C_EBREAK
/* 638 */     MCD::OPC_CheckPredicate, 1, 11, 0, 0, // Skip to: 654
/* 643 */     MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 654
/* 650 */     MCD::OPC_Decode, 240, 2, 24, // Opcode: C_ADD_HINT
/* 654 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 670
/* 659 */     MCD::OPC_CheckField, 2, 5, 0, 4, 0, 0, // Skip to: 670
/* 666 */     MCD::OPC_Decode, 128, 3, 21, // Opcode: C_JALR
/* 670 */     MCD::OPC_CheckPredicate, 0, 154, 0, 0, // Skip to: 829
/* 675 */     MCD::OPC_Decode, 231, 2, 25, // Opcode: C_ADD
/* 679 */     MCD::OPC_FilterValue, 5, 45, 0, 0, // Skip to: 729
/* 684 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 687 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 701
/* 692 */     MCD::OPC_CheckPredicate, 2, 132, 0, 0, // Skip to: 829
/* 697 */     MCD::OPC_Decode, 250, 2, 7, // Opcode: C_FSD
/* 701 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 715
/* 706 */     MCD::OPC_CheckPredicate, 0, 118, 0, 0, // Skip to: 829
/* 711 */     MCD::OPC_Decode, 254, 2, 26, // Opcode: C_J
/* 715 */     MCD::OPC_FilterValue, 2, 109, 0, 0, // Skip to: 829
/* 720 */     MCD::OPC_CheckPredicate, 2, 104, 0, 0, // Skip to: 829
/* 725 */     MCD::OPC_Decode, 251, 2, 27, // Opcode: C_FSDSP
/* 729 */     MCD::OPC_FilterValue, 6, 45, 0, 0, // Skip to: 779
/* 734 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 737 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 751
/* 742 */     MCD::OPC_CheckPredicate, 0, 82, 0, 0, // Skip to: 829
/* 747 */     MCD::OPC_Decode, 156, 3, 9, // Opcode: C_SW
/* 751 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 765
/* 756 */     MCD::OPC_CheckPredicate, 0, 68, 0, 0, // Skip to: 829
/* 761 */     MCD::OPC_Decode, 243, 2, 28, // Opcode: C_BEQZ
/* 765 */     MCD::OPC_FilterValue, 2, 59, 0, 0, // Skip to: 829
/* 770 */     MCD::OPC_CheckPredicate, 0, 54, 0, 0, // Skip to: 829
/* 775 */     MCD::OPC_Decode, 157, 3, 29, // Opcode: C_SWSP
/* 779 */     MCD::OPC_FilterValue, 7, 45, 0, 0, // Skip to: 829
/* 784 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 787 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 801
/* 792 */     MCD::OPC_CheckPredicate, 3, 32, 0, 0, // Skip to: 829
/* 797 */     MCD::OPC_Decode, 145, 3, 13, // Opcode: C_SD
/* 801 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 815
/* 806 */     MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 829
/* 811 */     MCD::OPC_Decode, 244, 2, 28, // Opcode: C_BNEZ
/* 815 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 829
/* 820 */     MCD::OPC_CheckPredicate, 3, 4, 0, 0, // Skip to: 829
/* 825 */     MCD::OPC_Decode, 146, 3, 30, // Opcode: C_SDSP
/* 829 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 0, 7,  // Inst{6-0} ...
/* 3 */       MCD::OPC_FilterValue, 3, 76, 0, 0, // Skip to: 84
/* 8 */       MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 11 */      MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 20
/* 16 */      MCD::OPC_Decode, 248, 3, 31, // Opcode: LB
/* 20 */      MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 29
/* 25 */      MCD::OPC_Decode, 251, 3, 31, // Opcode: LH
/* 29 */      MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 38
/* 34 */      MCD::OPC_Decode, 134, 4, 31, // Opcode: LW
/* 38 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 52
/* 43 */      MCD::OPC_CheckPredicate, 4, 68, 21, 0, // Skip to: 5492
/* 48 */      MCD::OPC_Decode, 250, 3, 31, // Opcode: LD
/* 52 */      MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 61
/* 57 */      MCD::OPC_Decode, 249, 3, 31, // Opcode: LBU
/* 61 */      MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 70
/* 66 */      MCD::OPC_Decode, 252, 3, 31, // Opcode: LHU
/* 70 */      MCD::OPC_FilterValue, 6, 41, 21, 0, // Skip to: 5492
/* 75 */      MCD::OPC_CheckPredicate, 4, 36, 21, 0, // Skip to: 5492
/* 80 */      MCD::OPC_Decode, 135, 4, 31, // Opcode: LWU
/* 84 */      MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 120
/* 89 */      MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 92 */      MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 106
/* 97 */      MCD::OPC_CheckPredicate, 5, 14, 21, 0, // Skip to: 5492
/* 102 */     MCD::OPC_Decode, 201, 3, 32, // Opcode: FLW
/* 106 */     MCD::OPC_FilterValue, 3, 5, 21, 0, // Skip to: 5492
/* 111 */     MCD::OPC_CheckPredicate, 6, 0, 21, 0, // Skip to: 5492
/* 116 */     MCD::OPC_Decode, 196, 3, 33, // Opcode: FLD
/* 120 */     MCD::OPC_FilterValue, 15, 52, 0, 0, // Skip to: 177
/* 125 */     MCD::OPC_ExtractField, 7, 13,  // Inst{19-7} ...
/* 128 */     MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 161
/* 133 */     MCD::OPC_ExtractField, 28, 4,  // Inst{31-28} ...
/* 136 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 145
/* 141 */     MCD::OPC_Decode, 191, 3, 34, // Opcode: FENCE
/* 145 */     MCD::OPC_FilterValue, 8, 222, 20, 0, // Skip to: 5492
/* 150 */     MCD::OPC_CheckField, 20, 8, 51, 215, 20, 0, // Skip to: 5492
/* 157 */     MCD::OPC_Decode, 193, 3, 0, // Opcode: FENCE_TSO
/* 161 */     MCD::OPC_FilterValue, 32, 206, 20, 0, // Skip to: 5492
/* 166 */     MCD::OPC_CheckField, 20, 12, 0, 199, 20, 0, // Skip to: 5492
/* 173 */     MCD::OPC_Decode, 192, 3, 0, // Opcode: FENCE_I
/* 177 */     MCD::OPC_FilterValue, 19, 224, 1, 0, // Skip to: 662
/* 182 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 185 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 194
/* 190 */     MCD::OPC_Decode, 236, 1, 31, // Opcode: ADDI
/* 194 */     MCD::OPC_FilterValue, 1, 30, 1, 0, // Skip to: 485
/* 199 */     MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 202 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 211
/* 207 */     MCD::OPC_Decode, 199, 4, 35, // Opcode: SLLI
/* 211 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 225
/* 216 */     MCD::OPC_CheckPredicate, 7, 151, 20, 0, // Skip to: 5492
/* 221 */     MCD::OPC_Decode, 196, 4, 36, // Opcode: SHFLI
/* 225 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 239
/* 230 */     MCD::OPC_CheckPredicate, 8, 137, 20, 0, // Skip to: 5492
/* 235 */     MCD::OPC_Decode, 204, 4, 35, // Opcode: SLOI
/* 239 */     MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 253
/* 244 */     MCD::OPC_CheckPredicate, 9, 123, 20, 0, // Skip to: 5492
/* 249 */     MCD::OPC_Decode, 179, 4, 35, // Opcode: SBSETI
/* 253 */     MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 267
/* 258 */     MCD::OPC_CheckPredicate, 9, 109, 20, 0, // Skip to: 5492
/* 263 */     MCD::OPC_Decode, 168, 4, 35, // Opcode: SBCLRI
/* 267 */     MCD::OPC_FilterValue, 24, 199, 0, 0, // Skip to: 471
/* 272 */     MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 275 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 289
/* 280 */     MCD::OPC_CheckPredicate, 8, 87, 20, 0, // Skip to: 5492
/* 285 */     MCD::OPC_Decode, 211, 2, 37, // Opcode: CLZ
/* 289 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 303
/* 294 */     MCD::OPC_CheckPredicate, 8, 73, 20, 0, // Skip to: 5492
/* 299 */     MCD::OPC_Decode, 229, 2, 37, // Opcode: CTZ
/* 303 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 317
/* 308 */     MCD::OPC_CheckPredicate, 8, 59, 20, 0, // Skip to: 5492
/* 313 */     MCD::OPC_Decode, 154, 4, 37, // Opcode: PCNT
/* 317 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 331
/* 322 */     MCD::OPC_CheckPredicate, 10, 45, 20, 0, // Skip to: 5492
/* 327 */     MCD::OPC_Decode, 201, 2, 37, // Opcode: BMATFLIP
/* 331 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 345
/* 336 */     MCD::OPC_CheckPredicate, 8, 31, 20, 0, // Skip to: 5492
/* 341 */     MCD::OPC_Decode, 191, 4, 37, // Opcode: SEXTB
/* 345 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 359
/* 350 */     MCD::OPC_CheckPredicate, 8, 17, 20, 0, // Skip to: 5492
/* 355 */     MCD::OPC_Decode, 192, 4, 37, // Opcode: SEXTH
/* 359 */     MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 373
/* 364 */     MCD::OPC_CheckPredicate, 11, 3, 20, 0, // Skip to: 5492
/* 369 */     MCD::OPC_Decode, 215, 2, 37, // Opcode: CRC32B
/* 373 */     MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 387
/* 378 */     MCD::OPC_CheckPredicate, 11, 245, 19, 0, // Skip to: 5492
/* 383 */     MCD::OPC_Decode, 221, 2, 37, // Opcode: CRC32H
/* 387 */     MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 401
/* 392 */     MCD::OPC_CheckPredicate, 11, 231, 19, 0, // Skip to: 5492
/* 397 */     MCD::OPC_Decode, 222, 2, 37, // Opcode: CRC32W
/* 401 */     MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 415
/* 406 */     MCD::OPC_CheckPredicate, 12, 217, 19, 0, // Skip to: 5492
/* 411 */     MCD::OPC_Decode, 220, 2, 37, // Opcode: CRC32D
/* 415 */     MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 429
/* 420 */     MCD::OPC_CheckPredicate, 11, 203, 19, 0, // Skip to: 5492
/* 425 */     MCD::OPC_Decode, 216, 2, 37, // Opcode: CRC32CB
/* 429 */     MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 443
/* 434 */     MCD::OPC_CheckPredicate, 11, 189, 19, 0, // Skip to: 5492
/* 439 */     MCD::OPC_Decode, 218, 2, 37, // Opcode: CRC32CH
/* 443 */     MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 457
/* 448 */     MCD::OPC_CheckPredicate, 11, 175, 19, 0, // Skip to: 5492
/* 453 */     MCD::OPC_Decode, 219, 2, 37, // Opcode: CRC32CW
/* 457 */     MCD::OPC_FilterValue, 27, 166, 19, 0, // Skip to: 5492
/* 462 */     MCD::OPC_CheckPredicate, 12, 161, 19, 0, // Skip to: 5492
/* 467 */     MCD::OPC_Decode, 217, 2, 37, // Opcode: CRC32CD
/* 471 */     MCD::OPC_FilterValue, 26, 152, 19, 0, // Skip to: 5492
/* 476 */     MCD::OPC_CheckPredicate, 9, 147, 19, 0, // Skip to: 5492
/* 481 */     MCD::OPC_Decode, 175, 4, 35, // Opcode: SBINVI
/* 485 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 494
/* 490 */     MCD::OPC_Decode, 208, 4, 31, // Opcode: SLTI
/* 494 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 503
/* 499 */     MCD::OPC_Decode, 209, 4, 31, // Opcode: SLTIU
/* 503 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 512
/* 508 */     MCD::OPC_Decode, 237, 4, 31, // Opcode: XORI
/* 512 */     MCD::OPC_FilterValue, 5, 127, 0, 0, // Skip to: 644
/* 517 */     MCD::OPC_ExtractField, 26, 1,  // Inst{26} ...
/* 520 */     MCD::OPC_FilterValue, 0, 105, 0, 0, // Skip to: 630
/* 525 */     MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 528 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 537
/* 533 */     MCD::OPC_Decode, 217, 4, 35, // Opcode: SRLI
/* 537 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 551
/* 542 */     MCD::OPC_CheckPredicate, 7, 81, 19, 0, // Skip to: 5492
/* 547 */     MCD::OPC_Decode, 231, 4, 36, // Opcode: UNSHFLI
/* 551 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 565
/* 556 */     MCD::OPC_CheckPredicate, 8, 67, 19, 0, // Skip to: 5492
/* 561 */     MCD::OPC_Decode, 221, 4, 35, // Opcode: SROI
/* 565 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 579
/* 570 */     MCD::OPC_CheckPredicate, 7, 53, 19, 0, // Skip to: 5492
/* 575 */     MCD::OPC_Decode, 239, 3, 35, // Opcode: GORCI
/* 579 */     MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 588
/* 584 */     MCD::OPC_Decode, 212, 4, 35, // Opcode: SRAI
/* 588 */     MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 602
/* 593 */     MCD::OPC_CheckPredicate, 9, 30, 19, 0, // Skip to: 5492
/* 598 */     MCD::OPC_Decode, 172, 4, 35, // Opcode: SBEXTI
/* 602 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 616
/* 607 */     MCD::OPC_CheckPredicate, 13, 16, 19, 0, // Skip to: 5492
/* 612 */     MCD::OPC_Decode, 163, 4, 35, // Opcode: RORI
/* 616 */     MCD::OPC_FilterValue, 13, 7, 19, 0, // Skip to: 5492
/* 621 */     MCD::OPC_CheckPredicate, 7, 2, 19, 0, // Skip to: 5492
/* 626 */     MCD::OPC_Decode, 243, 3, 35, // Opcode: GREVI
/* 630 */     MCD::OPC_FilterValue, 1, 249, 18, 0, // Skip to: 5492
/* 635 */     MCD::OPC_CheckPredicate, 14, 244, 18, 0, // Skip to: 5492
/* 640 */     MCD::OPC_Decode, 232, 3, 38, // Opcode: FSRI
/* 644 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 653
/* 649 */     MCD::OPC_Decode, 147, 4, 31, // Opcode: ORI
/* 653 */     MCD::OPC_FilterValue, 7, 226, 18, 0, // Skip to: 5492
/* 658 */     MCD::OPC_Decode, 187, 2, 31, // Opcode: ANDI
/* 662 */     MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 671
/* 667 */     MCD::OPC_Decode, 189, 2, 39, // Opcode: AUIPC
/* 671 */     MCD::OPC_FilterValue, 27, 66, 1, 0, // Skip to: 998
/* 676 */     MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 679 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 693
/* 684 */     MCD::OPC_CheckPredicate, 4, 195, 18, 0, // Skip to: 5492
/* 689 */     MCD::OPC_Decode, 237, 1, 31, // Opcode: ADDIW
/* 693 */     MCD::OPC_FilterValue, 1, 172, 0, 0, // Skip to: 870
/* 698 */     MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 701 */     MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 722
/* 706 */     MCD::OPC_CheckPredicate, 4, 173, 18, 0, // Skip to: 5492
/* 711 */     MCD::OPC_CheckField, 25, 1, 0, 166, 18, 0, // Skip to: 5492
/* 718 */     MCD::OPC_Decode, 201, 4, 40, // Opcode: SLLIW
/* 722 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 736
/* 727 */     MCD::OPC_CheckPredicate, 15, 152, 18, 0, // Skip to: 5492
/* 732 */     MCD::OPC_Decode, 200, 4, 35, // Opcode: SLLIUW
/* 736 */     MCD::OPC_FilterValue, 8, 16, 0, 0, // Skip to: 757
/* 741 */     MCD::OPC_CheckPredicate, 15, 138, 18, 0, // Skip to: 5492
/* 746 */     MCD::OPC_CheckField, 25, 1, 0, 131, 18, 0, // Skip to: 5492
/* 753 */     MCD::OPC_Decode, 205, 4, 40, // Opcode: SLOIW
/* 757 */     MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 778
/* 762 */     MCD::OPC_CheckPredicate, 16, 117, 18, 0, // Skip to: 5492
/* 767 */     MCD::OPC_CheckField, 25, 1, 0, 110, 18, 0, // Skip to: 5492
/* 774 */     MCD::OPC_Decode, 180, 4, 40, // Opcode: SBSETIW
/* 778 */     MCD::OPC_FilterValue, 18, 16, 0, 0, // Skip to: 799
/* 783 */     MCD::OPC_CheckPredicate, 16, 96, 18, 0, // Skip to: 5492
/* 788 */     MCD::OPC_CheckField, 25, 1, 0, 89, 18, 0, // Skip to: 5492
/* 795 */     MCD::OPC_Decode, 169, 4, 40, // Opcode: SBCLRIW
/* 799 */     MCD::OPC_FilterValue, 24, 45, 0, 0, // Skip to: 849
/* 804 */     MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 807 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 821
/* 812 */     MCD::OPC_CheckPredicate, 15, 67, 18, 0, // Skip to: 5492
/* 817 */     MCD::OPC_Decode, 212, 2, 37, // Opcode: CLZW
/* 821 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 835
/* 826 */     MCD::OPC_CheckPredicate, 15, 53, 18, 0, // Skip to: 5492
/* 831 */     MCD::OPC_Decode, 230, 2, 37, // Opcode: CTZW
/* 835 */     MCD::OPC_FilterValue, 2, 44, 18, 0, // Skip to: 5492
/* 840 */     MCD::OPC_CheckPredicate, 15, 39, 18, 0, // Skip to: 5492
/* 845 */     MCD::OPC_Decode, 155, 4, 37, // Opcode: PCNTW
/* 849 */     MCD::OPC_FilterValue, 26, 30, 18, 0, // Skip to: 5492
/* 854 */     MCD::OPC_CheckPredicate, 16, 25, 18, 0, // Skip to: 5492
/* 859 */     MCD::OPC_CheckField, 25, 1, 0, 18, 18, 0, // Skip to: 5492
/* 866 */     MCD::OPC_Decode, 176, 4, 40, // Opcode: SBINVIW
/* 870 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 884
/* 875 */     MCD::OPC_CheckPredicate, 15, 4, 18, 0, // Skip to: 5492
/* 880 */     MCD::OPC_Decode, 238, 1, 31, // Opcode: ADDIWU
/* 884 */     MCD::OPC_FilterValue, 5, 251, 17, 0, // Skip to: 5492
/* 889 */     MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 892 */     MCD::OPC_FilterValue, 0, 87, 0, 0, // Skip to: 984
/* 897 */     MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 900 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 914
/* 905 */     MCD::OPC_CheckPredicate, 4, 230, 17, 0, // Skip to: 5492
/* 910 */     MCD::OPC_Decode, 218, 4, 40, // Opcode: SRLIW
/* 914 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 928
/* 919 */     MCD::OPC_CheckPredicate, 15, 216, 17, 0, // Skip to: 5492
/* 924 */     MCD::OPC_Decode, 222, 4, 40, // Opcode: SROIW
/* 928 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 942
/* 933 */     MCD::OPC_CheckPredicate, 17, 202, 17, 0, // Skip to: 5492
/* 938 */     MCD::OPC_Decode, 240, 3, 40, // Opcode: GORCIW
/* 942 */     MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 956
/* 947 */     MCD::OPC_CheckPredicate, 4, 188, 17, 0, // Skip to: 5492
/* 952 */     MCD::OPC_Decode, 213, 4, 40, // Opcode: SRAIW
/* 956 */     MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 970
/* 961 */     MCD::OPC_CheckPredicate, 18, 174, 17, 0, // Skip to: 5492
/* 966 */     MCD::OPC_Decode, 164, 4, 40, // Opcode: RORIW
/* 970 */     MCD::OPC_FilterValue, 13, 165, 17, 0, // Skip to: 5492
/* 975 */     MCD::OPC_CheckPredicate, 17, 160, 17, 0, // Skip to: 5492
/* 980 */     MCD::OPC_Decode, 244, 3, 40, // Opcode: GREVIW
/* 984 */     MCD::OPC_FilterValue, 2, 151, 17, 0, // Skip to: 5492
/* 989 */     MCD::OPC_CheckPredicate, 19, 146, 17, 0, // Skip to: 5492
/* 994 */     MCD::OPC_Decode, 233, 3, 41, // Opcode: FSRIW
/* 998 */     MCD::OPC_FilterValue, 35, 44, 0, 0, // Skip to: 1047
/* 1003 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1006 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1015
/* 1011 */    MCD::OPC_Decode, 166, 4, 42, // Opcode: SB
/* 1015 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1024
/* 1020 */    MCD::OPC_Decode, 194, 4, 42, // Opcode: SH
/* 1024 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1033
/* 1029 */    MCD::OPC_Decode, 228, 4, 42, // Opcode: SW
/* 1033 */    MCD::OPC_FilterValue, 3, 102, 17, 0, // Skip to: 5492
/* 1038 */    MCD::OPC_CheckPredicate, 4, 97, 17, 0, // Skip to: 5492
/* 1043 */    MCD::OPC_Decode, 190, 4, 42, // Opcode: SD
/* 1047 */    MCD::OPC_FilterValue, 39, 31, 0, 0, // Skip to: 1083
/* 1052 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1055 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1069
/* 1060 */    MCD::OPC_CheckPredicate, 5, 75, 17, 0, // Skip to: 5492
/* 1065 */    MCD::OPC_Decode, 237, 3, 43, // Opcode: FSW
/* 1069 */    MCD::OPC_FilterValue, 3, 66, 17, 0, // Skip to: 5492
/* 1074 */    MCD::OPC_CheckPredicate, 6, 61, 17, 0, // Skip to: 5492
/* 1079 */    MCD::OPC_Decode, 220, 3, 44, // Opcode: FSD
/* 1083 */    MCD::OPC_FilterValue, 47, 107, 6, 0, // Skip to: 2731
/* 1088 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 1091 */    MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 1127
/* 1096 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1099 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1113
/* 1104 */    MCD::OPC_CheckPredicate, 20, 31, 17, 0, // Skip to: 5492
/* 1109 */    MCD::OPC_Decode, 246, 1, 45, // Opcode: AMOADD_W
/* 1113 */    MCD::OPC_FilterValue, 3, 22, 17, 0, // Skip to: 5492
/* 1118 */    MCD::OPC_CheckPredicate, 21, 17, 17, 0, // Skip to: 5492
/* 1123 */    MCD::OPC_Decode, 242, 1, 45, // Opcode: AMOADD_D
/* 1127 */    MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 1163
/* 1132 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1135 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1149
/* 1140 */    MCD::OPC_CheckPredicate, 20, 251, 16, 0, // Skip to: 5492
/* 1145 */    MCD::OPC_Decode, 249, 1, 45, // Opcode: AMOADD_W_RL
/* 1149 */    MCD::OPC_FilterValue, 3, 242, 16, 0, // Skip to: 5492
/* 1154 */    MCD::OPC_CheckPredicate, 21, 237, 16, 0, // Skip to: 5492
/* 1159 */    MCD::OPC_Decode, 245, 1, 45, // Opcode: AMOADD_D_RL
/* 1163 */    MCD::OPC_FilterValue, 2, 31, 0, 0, // Skip to: 1199
/* 1168 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1171 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1185
/* 1176 */    MCD::OPC_CheckPredicate, 20, 215, 16, 0, // Skip to: 5492
/* 1181 */    MCD::OPC_Decode, 247, 1, 45, // Opcode: AMOADD_W_AQ
/* 1185 */    MCD::OPC_FilterValue, 3, 206, 16, 0, // Skip to: 5492
/* 1190 */    MCD::OPC_CheckPredicate, 21, 201, 16, 0, // Skip to: 5492
/* 1195 */    MCD::OPC_Decode, 243, 1, 45, // Opcode: AMOADD_D_AQ
/* 1199 */    MCD::OPC_FilterValue, 3, 31, 0, 0, // Skip to: 1235
/* 1204 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1207 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1221
/* 1212 */    MCD::OPC_CheckPredicate, 20, 179, 16, 0, // Skip to: 5492
/* 1217 */    MCD::OPC_Decode, 248, 1, 45, // Opcode: AMOADD_W_AQ_RL
/* 1221 */    MCD::OPC_FilterValue, 3, 170, 16, 0, // Skip to: 5492
/* 1226 */    MCD::OPC_CheckPredicate, 21, 165, 16, 0, // Skip to: 5492
/* 1231 */    MCD::OPC_Decode, 244, 1, 45, // Opcode: AMOADD_D_AQ_RL
/* 1235 */    MCD::OPC_FilterValue, 4, 31, 0, 0, // Skip to: 1271
/* 1240 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1243 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1257
/* 1248 */    MCD::OPC_CheckPredicate, 20, 143, 16, 0, // Skip to: 5492
/* 1253 */    MCD::OPC_Decode, 174, 2, 45, // Opcode: AMOSWAP_W
/* 1257 */    MCD::OPC_FilterValue, 3, 134, 16, 0, // Skip to: 5492
/* 1262 */    MCD::OPC_CheckPredicate, 21, 129, 16, 0, // Skip to: 5492
/* 1267 */    MCD::OPC_Decode, 170, 2, 45, // Opcode: AMOSWAP_D
/* 1271 */    MCD::OPC_FilterValue, 5, 31, 0, 0, // Skip to: 1307
/* 1276 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1279 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1293
/* 1284 */    MCD::OPC_CheckPredicate, 20, 107, 16, 0, // Skip to: 5492
/* 1289 */    MCD::OPC_Decode, 177, 2, 45, // Opcode: AMOSWAP_W_RL
/* 1293 */    MCD::OPC_FilterValue, 3, 98, 16, 0, // Skip to: 5492
/* 1298 */    MCD::OPC_CheckPredicate, 21, 93, 16, 0, // Skip to: 5492
/* 1303 */    MCD::OPC_Decode, 173, 2, 45, // Opcode: AMOSWAP_D_RL
/* 1307 */    MCD::OPC_FilterValue, 6, 31, 0, 0, // Skip to: 1343
/* 1312 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1315 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1329
/* 1320 */    MCD::OPC_CheckPredicate, 20, 71, 16, 0, // Skip to: 5492
/* 1325 */    MCD::OPC_Decode, 175, 2, 45, // Opcode: AMOSWAP_W_AQ
/* 1329 */    MCD::OPC_FilterValue, 3, 62, 16, 0, // Skip to: 5492
/* 1334 */    MCD::OPC_CheckPredicate, 21, 57, 16, 0, // Skip to: 5492
/* 1339 */    MCD::OPC_Decode, 171, 2, 45, // Opcode: AMOSWAP_D_AQ
/* 1343 */    MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 1379
/* 1348 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1351 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1365
/* 1356 */    MCD::OPC_CheckPredicate, 20, 35, 16, 0, // Skip to: 5492
/* 1361 */    MCD::OPC_Decode, 176, 2, 45, // Opcode: AMOSWAP_W_AQ_RL
/* 1365 */    MCD::OPC_FilterValue, 3, 26, 16, 0, // Skip to: 5492
/* 1370 */    MCD::OPC_CheckPredicate, 21, 21, 16, 0, // Skip to: 5492
/* 1375 */    MCD::OPC_Decode, 172, 2, 45, // Opcode: AMOSWAP_D_AQ_RL
/* 1379 */    MCD::OPC_FilterValue, 8, 45, 0, 0, // Skip to: 1429
/* 1384 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1387 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 1408
/* 1392 */    MCD::OPC_CheckPredicate, 20, 255, 15, 0, // Skip to: 5492
/* 1397 */    MCD::OPC_CheckField, 20, 5, 0, 248, 15, 0, // Skip to: 5492
/* 1404 */    MCD::OPC_Decode, 129, 4, 37, // Opcode: LR_W
/* 1408 */    MCD::OPC_FilterValue, 3, 239, 15, 0, // Skip to: 5492
/* 1413 */    MCD::OPC_CheckPredicate, 21, 234, 15, 0, // Skip to: 5492
/* 1418 */    MCD::OPC_CheckField, 20, 5, 0, 227, 15, 0, // Skip to: 5492
/* 1425 */    MCD::OPC_Decode, 253, 3, 37, // Opcode: LR_D
/* 1429 */    MCD::OPC_FilterValue, 9, 45, 0, 0, // Skip to: 1479
/* 1434 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1437 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 1458
/* 1442 */    MCD::OPC_CheckPredicate, 20, 205, 15, 0, // Skip to: 5492
/* 1447 */    MCD::OPC_CheckField, 20, 5, 0, 198, 15, 0, // Skip to: 5492
/* 1454 */    MCD::OPC_Decode, 132, 4, 37, // Opcode: LR_W_RL
/* 1458 */    MCD::OPC_FilterValue, 3, 189, 15, 0, // Skip to: 5492
/* 1463 */    MCD::OPC_CheckPredicate, 21, 184, 15, 0, // Skip to: 5492
/* 1468 */    MCD::OPC_CheckField, 20, 5, 0, 177, 15, 0, // Skip to: 5492
/* 1475 */    MCD::OPC_Decode, 128, 4, 37, // Opcode: LR_D_RL
/* 1479 */    MCD::OPC_FilterValue, 10, 45, 0, 0, // Skip to: 1529
/* 1484 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1487 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 1508
/* 1492 */    MCD::OPC_CheckPredicate, 20, 155, 15, 0, // Skip to: 5492
/* 1497 */    MCD::OPC_CheckField, 20, 5, 0, 148, 15, 0, // Skip to: 5492
/* 1504 */    MCD::OPC_Decode, 130, 4, 37, // Opcode: LR_W_AQ
/* 1508 */    MCD::OPC_FilterValue, 3, 139, 15, 0, // Skip to: 5492
/* 1513 */    MCD::OPC_CheckPredicate, 21, 134, 15, 0, // Skip to: 5492
/* 1518 */    MCD::OPC_CheckField, 20, 5, 0, 127, 15, 0, // Skip to: 5492
/* 1525 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: LR_D_AQ
/* 1529 */    MCD::OPC_FilterValue, 11, 45, 0, 0, // Skip to: 1579
/* 1534 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1537 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 1558
/* 1542 */    MCD::OPC_CheckPredicate, 20, 105, 15, 0, // Skip to: 5492
/* 1547 */    MCD::OPC_CheckField, 20, 5, 0, 98, 15, 0, // Skip to: 5492
/* 1554 */    MCD::OPC_Decode, 131, 4, 37, // Opcode: LR_W_AQ_RL
/* 1558 */    MCD::OPC_FilterValue, 3, 89, 15, 0, // Skip to: 5492
/* 1563 */    MCD::OPC_CheckPredicate, 21, 84, 15, 0, // Skip to: 5492
/* 1568 */    MCD::OPC_CheckField, 20, 5, 0, 77, 15, 0, // Skip to: 5492
/* 1575 */    MCD::OPC_Decode, 255, 3, 37, // Opcode: LR_D_AQ_RL
/* 1579 */    MCD::OPC_FilterValue, 12, 31, 0, 0, // Skip to: 1615
/* 1584 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1587 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1601
/* 1592 */    MCD::OPC_CheckPredicate, 20, 55, 15, 0, // Skip to: 5492
/* 1597 */    MCD::OPC_Decode, 186, 4, 45, // Opcode: SC_W
/* 1601 */    MCD::OPC_FilterValue, 3, 46, 15, 0, // Skip to: 5492
/* 1606 */    MCD::OPC_CheckPredicate, 21, 41, 15, 0, // Skip to: 5492
/* 1611 */    MCD::OPC_Decode, 182, 4, 45, // Opcode: SC_D
/* 1615 */    MCD::OPC_FilterValue, 13, 31, 0, 0, // Skip to: 1651
/* 1620 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1623 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1637
/* 1628 */    MCD::OPC_CheckPredicate, 20, 19, 15, 0, // Skip to: 5492
/* 1633 */    MCD::OPC_Decode, 189, 4, 45, // Opcode: SC_W_RL
/* 1637 */    MCD::OPC_FilterValue, 3, 10, 15, 0, // Skip to: 5492
/* 1642 */    MCD::OPC_CheckPredicate, 21, 5, 15, 0, // Skip to: 5492
/* 1647 */    MCD::OPC_Decode, 185, 4, 45, // Opcode: SC_D_RL
/* 1651 */    MCD::OPC_FilterValue, 14, 31, 0, 0, // Skip to: 1687
/* 1656 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1659 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1673
/* 1664 */    MCD::OPC_CheckPredicate, 20, 239, 14, 0, // Skip to: 5492
/* 1669 */    MCD::OPC_Decode, 187, 4, 45, // Opcode: SC_W_AQ
/* 1673 */    MCD::OPC_FilterValue, 3, 230, 14, 0, // Skip to: 5492
/* 1678 */    MCD::OPC_CheckPredicate, 21, 225, 14, 0, // Skip to: 5492
/* 1683 */    MCD::OPC_Decode, 183, 4, 45, // Opcode: SC_D_AQ
/* 1687 */    MCD::OPC_FilterValue, 15, 31, 0, 0, // Skip to: 1723
/* 1692 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1695 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1709
/* 1700 */    MCD::OPC_CheckPredicate, 20, 203, 14, 0, // Skip to: 5492
/* 1705 */    MCD::OPC_Decode, 188, 4, 45, // Opcode: SC_W_AQ_RL
/* 1709 */    MCD::OPC_FilterValue, 3, 194, 14, 0, // Skip to: 5492
/* 1714 */    MCD::OPC_CheckPredicate, 21, 189, 14, 0, // Skip to: 5492
/* 1719 */    MCD::OPC_Decode, 184, 4, 45, // Opcode: SC_D_AQ_RL
/* 1723 */    MCD::OPC_FilterValue, 16, 31, 0, 0, // Skip to: 1759
/* 1728 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1731 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1745
/* 1736 */    MCD::OPC_CheckPredicate, 20, 167, 14, 0, // Skip to: 5492
/* 1741 */    MCD::OPC_Decode, 182, 2, 45, // Opcode: AMOXOR_W
/* 1745 */    MCD::OPC_FilterValue, 3, 158, 14, 0, // Skip to: 5492
/* 1750 */    MCD::OPC_CheckPredicate, 21, 153, 14, 0, // Skip to: 5492
/* 1755 */    MCD::OPC_Decode, 178, 2, 45, // Opcode: AMOXOR_D
/* 1759 */    MCD::OPC_FilterValue, 17, 31, 0, 0, // Skip to: 1795
/* 1764 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1767 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1781
/* 1772 */    MCD::OPC_CheckPredicate, 20, 131, 14, 0, // Skip to: 5492
/* 1777 */    MCD::OPC_Decode, 185, 2, 45, // Opcode: AMOXOR_W_RL
/* 1781 */    MCD::OPC_FilterValue, 3, 122, 14, 0, // Skip to: 5492
/* 1786 */    MCD::OPC_CheckPredicate, 21, 117, 14, 0, // Skip to: 5492
/* 1791 */    MCD::OPC_Decode, 181, 2, 45, // Opcode: AMOXOR_D_RL
/* 1795 */    MCD::OPC_FilterValue, 18, 31, 0, 0, // Skip to: 1831
/* 1800 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1803 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1817
/* 1808 */    MCD::OPC_CheckPredicate, 20, 95, 14, 0, // Skip to: 5492
/* 1813 */    MCD::OPC_Decode, 183, 2, 45, // Opcode: AMOXOR_W_AQ
/* 1817 */    MCD::OPC_FilterValue, 3, 86, 14, 0, // Skip to: 5492
/* 1822 */    MCD::OPC_CheckPredicate, 21, 81, 14, 0, // Skip to: 5492
/* 1827 */    MCD::OPC_Decode, 179, 2, 45, // Opcode: AMOXOR_D_AQ
/* 1831 */    MCD::OPC_FilterValue, 19, 31, 0, 0, // Skip to: 1867
/* 1836 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1839 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1853
/* 1844 */    MCD::OPC_CheckPredicate, 20, 59, 14, 0, // Skip to: 5492
/* 1849 */    MCD::OPC_Decode, 184, 2, 45, // Opcode: AMOXOR_W_AQ_RL
/* 1853 */    MCD::OPC_FilterValue, 3, 50, 14, 0, // Skip to: 5492
/* 1858 */    MCD::OPC_CheckPredicate, 21, 45, 14, 0, // Skip to: 5492
/* 1863 */    MCD::OPC_Decode, 180, 2, 45, // Opcode: AMOXOR_D_AQ_RL
/* 1867 */    MCD::OPC_FilterValue, 32, 31, 0, 0, // Skip to: 1903
/* 1872 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1875 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1889
/* 1880 */    MCD::OPC_CheckPredicate, 20, 23, 14, 0, // Skip to: 5492
/* 1885 */    MCD::OPC_Decode, 166, 2, 45, // Opcode: AMOOR_W
/* 1889 */    MCD::OPC_FilterValue, 3, 14, 14, 0, // Skip to: 5492
/* 1894 */    MCD::OPC_CheckPredicate, 21, 9, 14, 0, // Skip to: 5492
/* 1899 */    MCD::OPC_Decode, 162, 2, 45, // Opcode: AMOOR_D
/* 1903 */    MCD::OPC_FilterValue, 33, 31, 0, 0, // Skip to: 1939
/* 1908 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1911 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1925
/* 1916 */    MCD::OPC_CheckPredicate, 20, 243, 13, 0, // Skip to: 5492
/* 1921 */    MCD::OPC_Decode, 169, 2, 45, // Opcode: AMOOR_W_RL
/* 1925 */    MCD::OPC_FilterValue, 3, 234, 13, 0, // Skip to: 5492
/* 1930 */    MCD::OPC_CheckPredicate, 21, 229, 13, 0, // Skip to: 5492
/* 1935 */    MCD::OPC_Decode, 165, 2, 45, // Opcode: AMOOR_D_RL
/* 1939 */    MCD::OPC_FilterValue, 34, 31, 0, 0, // Skip to: 1975
/* 1944 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1947 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1961
/* 1952 */    MCD::OPC_CheckPredicate, 20, 207, 13, 0, // Skip to: 5492
/* 1957 */    MCD::OPC_Decode, 167, 2, 45, // Opcode: AMOOR_W_AQ
/* 1961 */    MCD::OPC_FilterValue, 3, 198, 13, 0, // Skip to: 5492
/* 1966 */    MCD::OPC_CheckPredicate, 21, 193, 13, 0, // Skip to: 5492
/* 1971 */    MCD::OPC_Decode, 163, 2, 45, // Opcode: AMOOR_D_AQ
/* 1975 */    MCD::OPC_FilterValue, 35, 31, 0, 0, // Skip to: 2011
/* 1980 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 1983 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1997
/* 1988 */    MCD::OPC_CheckPredicate, 20, 171, 13, 0, // Skip to: 5492
/* 1993 */    MCD::OPC_Decode, 168, 2, 45, // Opcode: AMOOR_W_AQ_RL
/* 1997 */    MCD::OPC_FilterValue, 3, 162, 13, 0, // Skip to: 5492
/* 2002 */    MCD::OPC_CheckPredicate, 21, 157, 13, 0, // Skip to: 5492
/* 2007 */    MCD::OPC_Decode, 164, 2, 45, // Opcode: AMOOR_D_AQ_RL
/* 2011 */    MCD::OPC_FilterValue, 48, 31, 0, 0, // Skip to: 2047
/* 2016 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2019 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2033
/* 2024 */    MCD::OPC_CheckPredicate, 20, 135, 13, 0, // Skip to: 5492
/* 2029 */    MCD::OPC_Decode, 254, 1, 45, // Opcode: AMOAND_W
/* 2033 */    MCD::OPC_FilterValue, 3, 126, 13, 0, // Skip to: 5492
/* 2038 */    MCD::OPC_CheckPredicate, 21, 121, 13, 0, // Skip to: 5492
/* 2043 */    MCD::OPC_Decode, 250, 1, 45, // Opcode: AMOAND_D
/* 2047 */    MCD::OPC_FilterValue, 49, 31, 0, 0, // Skip to: 2083
/* 2052 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2055 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2069
/* 2060 */    MCD::OPC_CheckPredicate, 20, 99, 13, 0, // Skip to: 5492
/* 2065 */    MCD::OPC_Decode, 129, 2, 45, // Opcode: AMOAND_W_RL
/* 2069 */    MCD::OPC_FilterValue, 3, 90, 13, 0, // Skip to: 5492
/* 2074 */    MCD::OPC_CheckPredicate, 21, 85, 13, 0, // Skip to: 5492
/* 2079 */    MCD::OPC_Decode, 253, 1, 45, // Opcode: AMOAND_D_RL
/* 2083 */    MCD::OPC_FilterValue, 50, 31, 0, 0, // Skip to: 2119
/* 2088 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2091 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2105
/* 2096 */    MCD::OPC_CheckPredicate, 20, 63, 13, 0, // Skip to: 5492
/* 2101 */    MCD::OPC_Decode, 255, 1, 45, // Opcode: AMOAND_W_AQ
/* 2105 */    MCD::OPC_FilterValue, 3, 54, 13, 0, // Skip to: 5492
/* 2110 */    MCD::OPC_CheckPredicate, 21, 49, 13, 0, // Skip to: 5492
/* 2115 */    MCD::OPC_Decode, 251, 1, 45, // Opcode: AMOAND_D_AQ
/* 2119 */    MCD::OPC_FilterValue, 51, 31, 0, 0, // Skip to: 2155
/* 2124 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2127 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2141
/* 2132 */    MCD::OPC_CheckPredicate, 20, 27, 13, 0, // Skip to: 5492
/* 2137 */    MCD::OPC_Decode, 128, 2, 45, // Opcode: AMOAND_W_AQ_RL
/* 2141 */    MCD::OPC_FilterValue, 3, 18, 13, 0, // Skip to: 5492
/* 2146 */    MCD::OPC_CheckPredicate, 21, 13, 13, 0, // Skip to: 5492
/* 2151 */    MCD::OPC_Decode, 252, 1, 45, // Opcode: AMOAND_D_AQ_RL
/* 2155 */    MCD::OPC_FilterValue, 64, 31, 0, 0, // Skip to: 2191
/* 2160 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2163 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2177
/* 2168 */    MCD::OPC_CheckPredicate, 20, 247, 12, 0, // Skip to: 5492
/* 2173 */    MCD::OPC_Decode, 158, 2, 45, // Opcode: AMOMIN_W
/* 2177 */    MCD::OPC_FilterValue, 3, 238, 12, 0, // Skip to: 5492
/* 2182 */    MCD::OPC_CheckPredicate, 21, 233, 12, 0, // Skip to: 5492
/* 2187 */    MCD::OPC_Decode, 154, 2, 45, // Opcode: AMOMIN_D
/* 2191 */    MCD::OPC_FilterValue, 65, 31, 0, 0, // Skip to: 2227
/* 2196 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2199 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2213
/* 2204 */    MCD::OPC_CheckPredicate, 20, 211, 12, 0, // Skip to: 5492
/* 2209 */    MCD::OPC_Decode, 161, 2, 45, // Opcode: AMOMIN_W_RL
/* 2213 */    MCD::OPC_FilterValue, 3, 202, 12, 0, // Skip to: 5492
/* 2218 */    MCD::OPC_CheckPredicate, 21, 197, 12, 0, // Skip to: 5492
/* 2223 */    MCD::OPC_Decode, 157, 2, 45, // Opcode: AMOMIN_D_RL
/* 2227 */    MCD::OPC_FilterValue, 66, 31, 0, 0, // Skip to: 2263
/* 2232 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2235 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2249
/* 2240 */    MCD::OPC_CheckPredicate, 20, 175, 12, 0, // Skip to: 5492
/* 2245 */    MCD::OPC_Decode, 159, 2, 45, // Opcode: AMOMIN_W_AQ
/* 2249 */    MCD::OPC_FilterValue, 3, 166, 12, 0, // Skip to: 5492
/* 2254 */    MCD::OPC_CheckPredicate, 21, 161, 12, 0, // Skip to: 5492
/* 2259 */    MCD::OPC_Decode, 155, 2, 45, // Opcode: AMOMIN_D_AQ
/* 2263 */    MCD::OPC_FilterValue, 67, 31, 0, 0, // Skip to: 2299
/* 2268 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2271 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2285
/* 2276 */    MCD::OPC_CheckPredicate, 20, 139, 12, 0, // Skip to: 5492
/* 2281 */    MCD::OPC_Decode, 160, 2, 45, // Opcode: AMOMIN_W_AQ_RL
/* 2285 */    MCD::OPC_FilterValue, 3, 130, 12, 0, // Skip to: 5492
/* 2290 */    MCD::OPC_CheckPredicate, 21, 125, 12, 0, // Skip to: 5492
/* 2295 */    MCD::OPC_Decode, 156, 2, 45, // Opcode: AMOMIN_D_AQ_RL
/* 2299 */    MCD::OPC_FilterValue, 80, 31, 0, 0, // Skip to: 2335
/* 2304 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2307 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2321
/* 2312 */    MCD::OPC_CheckPredicate, 20, 103, 12, 0, // Skip to: 5492
/* 2317 */    MCD::OPC_Decode, 142, 2, 45, // Opcode: AMOMAX_W
/* 2321 */    MCD::OPC_FilterValue, 3, 94, 12, 0, // Skip to: 5492
/* 2326 */    MCD::OPC_CheckPredicate, 21, 89, 12, 0, // Skip to: 5492
/* 2331 */    MCD::OPC_Decode, 138, 2, 45, // Opcode: AMOMAX_D
/* 2335 */    MCD::OPC_FilterValue, 81, 31, 0, 0, // Skip to: 2371
/* 2340 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2343 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2357
/* 2348 */    MCD::OPC_CheckPredicate, 20, 67, 12, 0, // Skip to: 5492
/* 2353 */    MCD::OPC_Decode, 145, 2, 45, // Opcode: AMOMAX_W_RL
/* 2357 */    MCD::OPC_FilterValue, 3, 58, 12, 0, // Skip to: 5492
/* 2362 */    MCD::OPC_CheckPredicate, 21, 53, 12, 0, // Skip to: 5492
/* 2367 */    MCD::OPC_Decode, 141, 2, 45, // Opcode: AMOMAX_D_RL
/* 2371 */    MCD::OPC_FilterValue, 82, 31, 0, 0, // Skip to: 2407
/* 2376 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2379 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2393
/* 2384 */    MCD::OPC_CheckPredicate, 20, 31, 12, 0, // Skip to: 5492
/* 2389 */    MCD::OPC_Decode, 143, 2, 45, // Opcode: AMOMAX_W_AQ
/* 2393 */    MCD::OPC_FilterValue, 3, 22, 12, 0, // Skip to: 5492
/* 2398 */    MCD::OPC_CheckPredicate, 21, 17, 12, 0, // Skip to: 5492
/* 2403 */    MCD::OPC_Decode, 139, 2, 45, // Opcode: AMOMAX_D_AQ
/* 2407 */    MCD::OPC_FilterValue, 83, 31, 0, 0, // Skip to: 2443
/* 2412 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2415 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2429
/* 2420 */    MCD::OPC_CheckPredicate, 20, 251, 11, 0, // Skip to: 5492
/* 2425 */    MCD::OPC_Decode, 144, 2, 45, // Opcode: AMOMAX_W_AQ_RL
/* 2429 */    MCD::OPC_FilterValue, 3, 242, 11, 0, // Skip to: 5492
/* 2434 */    MCD::OPC_CheckPredicate, 21, 237, 11, 0, // Skip to: 5492
/* 2439 */    MCD::OPC_Decode, 140, 2, 45, // Opcode: AMOMAX_D_AQ_RL
/* 2443 */    MCD::OPC_FilterValue, 96, 31, 0, 0, // Skip to: 2479
/* 2448 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2451 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2465
/* 2456 */    MCD::OPC_CheckPredicate, 20, 215, 11, 0, // Skip to: 5492
/* 2461 */    MCD::OPC_Decode, 150, 2, 45, // Opcode: AMOMINU_W
/* 2465 */    MCD::OPC_FilterValue, 3, 206, 11, 0, // Skip to: 5492
/* 2470 */    MCD::OPC_CheckPredicate, 21, 201, 11, 0, // Skip to: 5492
/* 2475 */    MCD::OPC_Decode, 146, 2, 45, // Opcode: AMOMINU_D
/* 2479 */    MCD::OPC_FilterValue, 97, 31, 0, 0, // Skip to: 2515
/* 2484 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2487 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2501
/* 2492 */    MCD::OPC_CheckPredicate, 20, 179, 11, 0, // Skip to: 5492
/* 2497 */    MCD::OPC_Decode, 153, 2, 45, // Opcode: AMOMINU_W_RL
/* 2501 */    MCD::OPC_FilterValue, 3, 170, 11, 0, // Skip to: 5492
/* 2506 */    MCD::OPC_CheckPredicate, 21, 165, 11, 0, // Skip to: 5492
/* 2511 */    MCD::OPC_Decode, 149, 2, 45, // Opcode: AMOMINU_D_RL
/* 2515 */    MCD::OPC_FilterValue, 98, 31, 0, 0, // Skip to: 2551
/* 2520 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2523 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2537
/* 2528 */    MCD::OPC_CheckPredicate, 20, 143, 11, 0, // Skip to: 5492
/* 2533 */    MCD::OPC_Decode, 151, 2, 45, // Opcode: AMOMINU_W_AQ
/* 2537 */    MCD::OPC_FilterValue, 3, 134, 11, 0, // Skip to: 5492
/* 2542 */    MCD::OPC_CheckPredicate, 21, 129, 11, 0, // Skip to: 5492
/* 2547 */    MCD::OPC_Decode, 147, 2, 45, // Opcode: AMOMINU_D_AQ
/* 2551 */    MCD::OPC_FilterValue, 99, 31, 0, 0, // Skip to: 2587
/* 2556 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2559 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2573
/* 2564 */    MCD::OPC_CheckPredicate, 20, 107, 11, 0, // Skip to: 5492
/* 2569 */    MCD::OPC_Decode, 152, 2, 45, // Opcode: AMOMINU_W_AQ_RL
/* 2573 */    MCD::OPC_FilterValue, 3, 98, 11, 0, // Skip to: 5492
/* 2578 */    MCD::OPC_CheckPredicate, 21, 93, 11, 0, // Skip to: 5492
/* 2583 */    MCD::OPC_Decode, 148, 2, 45, // Opcode: AMOMINU_D_AQ_RL
/* 2587 */    MCD::OPC_FilterValue, 112, 31, 0, 0, // Skip to: 2623
/* 2592 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2595 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2609
/* 2600 */    MCD::OPC_CheckPredicate, 20, 71, 11, 0, // Skip to: 5492
/* 2605 */    MCD::OPC_Decode, 134, 2, 45, // Opcode: AMOMAXU_W
/* 2609 */    MCD::OPC_FilterValue, 3, 62, 11, 0, // Skip to: 5492
/* 2614 */    MCD::OPC_CheckPredicate, 21, 57, 11, 0, // Skip to: 5492
/* 2619 */    MCD::OPC_Decode, 130, 2, 45, // Opcode: AMOMAXU_D
/* 2623 */    MCD::OPC_FilterValue, 113, 31, 0, 0, // Skip to: 2659
/* 2628 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2631 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2645
/* 2636 */    MCD::OPC_CheckPredicate, 20, 35, 11, 0, // Skip to: 5492
/* 2641 */    MCD::OPC_Decode, 137, 2, 45, // Opcode: AMOMAXU_W_RL
/* 2645 */    MCD::OPC_FilterValue, 3, 26, 11, 0, // Skip to: 5492
/* 2650 */    MCD::OPC_CheckPredicate, 21, 21, 11, 0, // Skip to: 5492
/* 2655 */    MCD::OPC_Decode, 133, 2, 45, // Opcode: AMOMAXU_D_RL
/* 2659 */    MCD::OPC_FilterValue, 114, 31, 0, 0, // Skip to: 2695
/* 2664 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2667 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2681
/* 2672 */    MCD::OPC_CheckPredicate, 20, 255, 10, 0, // Skip to: 5492
/* 2677 */    MCD::OPC_Decode, 135, 2, 45, // Opcode: AMOMAXU_W_AQ
/* 2681 */    MCD::OPC_FilterValue, 3, 246, 10, 0, // Skip to: 5492
/* 2686 */    MCD::OPC_CheckPredicate, 21, 241, 10, 0, // Skip to: 5492
/* 2691 */    MCD::OPC_Decode, 131, 2, 45, // Opcode: AMOMAXU_D_AQ
/* 2695 */    MCD::OPC_FilterValue, 115, 232, 10, 0, // Skip to: 5492
/* 2700 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2703 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2717
/* 2708 */    MCD::OPC_CheckPredicate, 20, 219, 10, 0, // Skip to: 5492
/* 2713 */    MCD::OPC_Decode, 136, 2, 45, // Opcode: AMOMAXU_W_AQ_RL
/* 2717 */    MCD::OPC_FilterValue, 3, 210, 10, 0, // Skip to: 5492
/* 2722 */    MCD::OPC_CheckPredicate, 21, 205, 10, 0, // Skip to: 5492
/* 2727 */    MCD::OPC_Decode, 132, 2, 45, // Opcode: AMOMAXU_D_AQ_RL
/* 2731 */    MCD::OPC_FilterValue, 51, 9, 3, 0, // Skip to: 3513
/* 2736 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 2739 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 2779
/* 2744 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2747 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2756
/* 2752 */    MCD::OPC_Decode, 235, 1, 45, // Opcode: ADD
/* 2756 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2770
/* 2761 */    MCD::OPC_CheckPredicate, 22, 166, 10, 0, // Skip to: 5492
/* 2766 */    MCD::OPC_Decode, 141, 4, 45, // Opcode: MUL
/* 2770 */    MCD::OPC_FilterValue, 32, 157, 10, 0, // Skip to: 5492
/* 2775 */    MCD::OPC_Decode, 224, 4, 45, // Opcode: SUB
/* 2779 */    MCD::OPC_FilterValue, 1, 168, 0, 0, // Skip to: 2952
/* 2784 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 2787 */    MCD::OPC_FilterValue, 0, 96, 0, 0, // Skip to: 2888
/* 2792 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 2795 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2804
/* 2800 */    MCD::OPC_Decode, 198, 4, 45, // Opcode: SLL
/* 2804 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2818
/* 2809 */    MCD::OPC_CheckPredicate, 7, 118, 10, 0, // Skip to: 5492
/* 2814 */    MCD::OPC_Decode, 195, 4, 45, // Opcode: SHFL
/* 2818 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 2832
/* 2823 */    MCD::OPC_CheckPredicate, 8, 104, 10, 0, // Skip to: 5492
/* 2828 */    MCD::OPC_Decode, 203, 4, 45, // Opcode: SLO
/* 2832 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2846
/* 2837 */    MCD::OPC_CheckPredicate, 9, 90, 10, 0, // Skip to: 5492
/* 2842 */    MCD::OPC_Decode, 178, 4, 45, // Opcode: SBSET
/* 2846 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 2860
/* 2851 */    MCD::OPC_CheckPredicate, 9, 76, 10, 0, // Skip to: 5492
/* 2856 */    MCD::OPC_Decode, 167, 4, 45, // Opcode: SBCLR
/* 2860 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 2874
/* 2865 */    MCD::OPC_CheckPredicate, 13, 62, 10, 0, // Skip to: 5492
/* 2870 */    MCD::OPC_Decode, 160, 4, 45, // Opcode: ROL
/* 2874 */    MCD::OPC_FilterValue, 13, 53, 10, 0, // Skip to: 5492
/* 2879 */    MCD::OPC_CheckPredicate, 9, 48, 10, 0, // Skip to: 5492
/* 2884 */    MCD::OPC_Decode, 174, 4, 45, // Opcode: SBINV
/* 2888 */    MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 2924
/* 2893 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 2896 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2910
/* 2901 */    MCD::OPC_CheckPredicate, 22, 26, 10, 0, // Skip to: 5492
/* 2906 */    MCD::OPC_Decode, 142, 4, 45, // Opcode: MULH
/* 2910 */    MCD::OPC_FilterValue, 1, 17, 10, 0, // Skip to: 5492
/* 2915 */    MCD::OPC_CheckPredicate, 23, 12, 10, 0, // Skip to: 5492
/* 2920 */    MCD::OPC_Decode, 205, 2, 45, // Opcode: CLMUL
/* 2924 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 2938
/* 2929 */    MCD::OPC_CheckPredicate, 14, 254, 9, 0, // Skip to: 5492
/* 2934 */    MCD::OPC_Decode, 227, 3, 46, // Opcode: FSL
/* 2938 */    MCD::OPC_FilterValue, 3, 245, 9, 0, // Skip to: 5492
/* 2943 */    MCD::OPC_CheckPredicate, 14, 240, 9, 0, // Skip to: 5492
/* 2948 */    MCD::OPC_Decode, 213, 2, 46, // Opcode: CMIX
/* 2952 */    MCD::OPC_FilterValue, 2, 40, 0, 0, // Skip to: 2997
/* 2957 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 2960 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2969
/* 2965 */    MCD::OPC_Decode, 207, 4, 45, // Opcode: SLT
/* 2969 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 2983
/* 2974 */    MCD::OPC_CheckPredicate, 22, 209, 9, 0, // Skip to: 5492
/* 2979 */    MCD::OPC_Decode, 143, 4, 45, // Opcode: MULHSU
/* 2983 */    MCD::OPC_FilterValue, 5, 200, 9, 0, // Skip to: 5492
/* 2988 */    MCD::OPC_CheckPredicate, 23, 195, 9, 0, // Skip to: 5492
/* 2993 */    MCD::OPC_Decode, 208, 2, 45, // Opcode: CLMULR
/* 2997 */    MCD::OPC_FilterValue, 3, 68, 0, 0, // Skip to: 3070
/* 3002 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3005 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3014
/* 3010 */    MCD::OPC_Decode, 210, 4, 45, // Opcode: SLTU
/* 3014 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3028
/* 3019 */    MCD::OPC_CheckPredicate, 22, 164, 9, 0, // Skip to: 5492
/* 3024 */    MCD::OPC_Decode, 144, 4, 45, // Opcode: MULHU
/* 3028 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3042
/* 3033 */    MCD::OPC_CheckPredicate, 10, 150, 9, 0, // Skip to: 5492
/* 3038 */    MCD::OPC_Decode, 202, 2, 45, // Opcode: BMATOR
/* 3042 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3056
/* 3047 */    MCD::OPC_CheckPredicate, 23, 136, 9, 0, // Skip to: 5492
/* 3052 */    MCD::OPC_Decode, 206, 2, 45, // Opcode: CLMULH
/* 3056 */    MCD::OPC_FilterValue, 36, 127, 9, 0, // Skip to: 5492
/* 3061 */    MCD::OPC_CheckPredicate, 10, 122, 9, 0, // Skip to: 5492
/* 3066 */    MCD::OPC_Decode, 203, 2, 45, // Opcode: BMATXOR
/* 3070 */    MCD::OPC_FilterValue, 4, 82, 0, 0, // Skip to: 3157
/* 3075 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3078 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3087
/* 3083 */    MCD::OPC_Decode, 236, 4, 45, // Opcode: XOR
/* 3087 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3101
/* 3092 */    MCD::OPC_CheckPredicate, 22, 91, 9, 0, // Skip to: 5492
/* 3097 */    MCD::OPC_Decode, 161, 3, 45, // Opcode: DIV
/* 3101 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3115
/* 3106 */    MCD::OPC_CheckPredicate, 13, 77, 9, 0, // Skip to: 5492
/* 3111 */    MCD::OPC_Decode, 149, 4, 45, // Opcode: PACK
/* 3115 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3129
/* 3120 */    MCD::OPC_CheckPredicate, 8, 63, 9, 0, // Skip to: 5492
/* 3125 */    MCD::OPC_Decode, 138, 4, 45, // Opcode: MIN
/* 3129 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 3143
/* 3134 */    MCD::OPC_CheckPredicate, 13, 49, 9, 0, // Skip to: 5492
/* 3139 */    MCD::OPC_Decode, 235, 4, 45, // Opcode: XNOR
/* 3143 */    MCD::OPC_FilterValue, 36, 40, 9, 0, // Skip to: 5492
/* 3148 */    MCD::OPC_CheckPredicate, 13, 35, 9, 0, // Skip to: 5492
/* 3153 */    MCD::OPC_Decode, 151, 4, 45, // Opcode: PACKU
/* 3157 */    MCD::OPC_FilterValue, 5, 177, 0, 0, // Skip to: 3339
/* 3162 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 3165 */    MCD::OPC_FilterValue, 0, 105, 0, 0, // Skip to: 3275
/* 3170 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 3173 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3182
/* 3178 */    MCD::OPC_Decode, 216, 4, 45, // Opcode: SRL
/* 3182 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3196
/* 3187 */    MCD::OPC_CheckPredicate, 7, 252, 8, 0, // Skip to: 5492
/* 3192 */    MCD::OPC_Decode, 230, 4, 45, // Opcode: UNSHFL
/* 3196 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3210
/* 3201 */    MCD::OPC_CheckPredicate, 8, 238, 8, 0, // Skip to: 5492
/* 3206 */    MCD::OPC_Decode, 220, 4, 45, // Opcode: SRO
/* 3210 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3224
/* 3215 */    MCD::OPC_CheckPredicate, 7, 224, 8, 0, // Skip to: 5492
/* 3220 */    MCD::OPC_Decode, 238, 3, 45, // Opcode: GORC
/* 3224 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3233
/* 3229 */    MCD::OPC_Decode, 211, 4, 45, // Opcode: SRA
/* 3233 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 3247
/* 3238 */    MCD::OPC_CheckPredicate, 9, 201, 8, 0, // Skip to: 5492
/* 3243 */    MCD::OPC_Decode, 171, 4, 45, // Opcode: SBEXT
/* 3247 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 3261
/* 3252 */    MCD::OPC_CheckPredicate, 13, 187, 8, 0, // Skip to: 5492
/* 3257 */    MCD::OPC_Decode, 162, 4, 45, // Opcode: ROR
/* 3261 */    MCD::OPC_FilterValue, 13, 178, 8, 0, // Skip to: 5492
/* 3266 */    MCD::OPC_CheckPredicate, 7, 173, 8, 0, // Skip to: 5492
/* 3271 */    MCD::OPC_Decode, 242, 3, 45, // Opcode: GREV
/* 3275 */    MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 3311
/* 3280 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 3283 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3297
/* 3288 */    MCD::OPC_CheckPredicate, 22, 151, 8, 0, // Skip to: 5492
/* 3293 */    MCD::OPC_Decode, 162, 3, 45, // Opcode: DIVU
/* 3297 */    MCD::OPC_FilterValue, 1, 142, 8, 0, // Skip to: 5492
/* 3302 */    MCD::OPC_CheckPredicate, 8, 137, 8, 0, // Skip to: 5492
/* 3307 */    MCD::OPC_Decode, 136, 4, 45, // Opcode: MAX
/* 3311 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3325
/* 3316 */    MCD::OPC_CheckPredicate, 14, 123, 8, 0, // Skip to: 5492
/* 3321 */    MCD::OPC_Decode, 231, 3, 46, // Opcode: FSR
/* 3325 */    MCD::OPC_FilterValue, 3, 114, 8, 0, // Skip to: 5492
/* 3330 */    MCD::OPC_CheckPredicate, 14, 109, 8, 0, // Skip to: 5492
/* 3335 */    MCD::OPC_Decode, 214, 2, 46, // Opcode: CMOV
/* 3339 */    MCD::OPC_FilterValue, 6, 82, 0, 0, // Skip to: 3426
/* 3344 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3347 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3356
/* 3352 */    MCD::OPC_Decode, 146, 4, 45, // Opcode: OR
/* 3356 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3370
/* 3361 */    MCD::OPC_CheckPredicate, 22, 78, 8, 0, // Skip to: 5492
/* 3366 */    MCD::OPC_Decode, 156, 4, 45, // Opcode: REM
/* 3370 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3384
/* 3375 */    MCD::OPC_CheckPredicate, 24, 64, 8, 0, // Skip to: 5492
/* 3380 */    MCD::OPC_Decode, 193, 2, 45, // Opcode: BEXT
/* 3384 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3398
/* 3389 */    MCD::OPC_CheckPredicate, 8, 50, 8, 0, // Skip to: 5492
/* 3394 */    MCD::OPC_Decode, 139, 4, 45, // Opcode: MINU
/* 3398 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 3412
/* 3403 */    MCD::OPC_CheckPredicate, 13, 36, 8, 0, // Skip to: 5492
/* 3408 */    MCD::OPC_Decode, 148, 4, 45, // Opcode: ORN
/* 3412 */    MCD::OPC_FilterValue, 36, 27, 8, 0, // Skip to: 5492
/* 3417 */    MCD::OPC_CheckPredicate, 24, 22, 8, 0, // Skip to: 5492
/* 3422 */    MCD::OPC_Decode, 190, 2, 45, // Opcode: BDEP
/* 3426 */    MCD::OPC_FilterValue, 7, 13, 8, 0, // Skip to: 5492
/* 3431 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3434 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3443
/* 3439 */    MCD::OPC_Decode, 186, 2, 45, // Opcode: AND
/* 3443 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3457
/* 3448 */    MCD::OPC_CheckPredicate, 22, 247, 7, 0, // Skip to: 5492
/* 3453 */    MCD::OPC_Decode, 157, 4, 45, // Opcode: REMU
/* 3457 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3471
/* 3462 */    MCD::OPC_CheckPredicate, 13, 233, 7, 0, // Skip to: 5492
/* 3467 */    MCD::OPC_Decode, 150, 4, 45, // Opcode: PACKH
/* 3471 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3485
/* 3476 */    MCD::OPC_CheckPredicate, 8, 219, 7, 0, // Skip to: 5492
/* 3481 */    MCD::OPC_Decode, 137, 4, 45, // Opcode: MAXU
/* 3485 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 3499
/* 3490 */    MCD::OPC_CheckPredicate, 13, 205, 7, 0, // Skip to: 5492
/* 3495 */    MCD::OPC_Decode, 188, 2, 45, // Opcode: ANDN
/* 3499 */    MCD::OPC_FilterValue, 36, 196, 7, 0, // Skip to: 5492
/* 3504 */    MCD::OPC_CheckPredicate, 25, 191, 7, 0, // Skip to: 5492
/* 3509 */    MCD::OPC_Decode, 195, 2, 45, // Opcode: BFP
/* 3513 */    MCD::OPC_FilterValue, 55, 4, 0, 0, // Skip to: 3522
/* 3518 */    MCD::OPC_Decode, 133, 4, 39, // Opcode: LUI
/* 3522 */    MCD::OPC_FilterValue, 59, 87, 2, 0, // Skip to: 4126
/* 3527 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 3530 */    MCD::OPC_FilterValue, 0, 101, 0, 0, // Skip to: 3636
/* 3535 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3538 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3552
/* 3543 */    MCD::OPC_CheckPredicate, 4, 152, 7, 0, // Skip to: 5492
/* 3548 */    MCD::OPC_Decode, 240, 1, 45, // Opcode: ADDW
/* 3552 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3566
/* 3557 */    MCD::OPC_CheckPredicate, 26, 138, 7, 0, // Skip to: 5492
/* 3562 */    MCD::OPC_Decode, 145, 4, 45, // Opcode: MULW
/* 3566 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3580
/* 3571 */    MCD::OPC_CheckPredicate, 15, 124, 7, 0, // Skip to: 5492
/* 3576 */    MCD::OPC_Decode, 239, 1, 45, // Opcode: ADDUW
/* 3580 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3594
/* 3585 */    MCD::OPC_CheckPredicate, 15, 110, 7, 0, // Skip to: 5492
/* 3590 */    MCD::OPC_Decode, 241, 1, 45, // Opcode: ADDWU
/* 3594 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 3608
/* 3599 */    MCD::OPC_CheckPredicate, 4, 96, 7, 0, // Skip to: 5492
/* 3604 */    MCD::OPC_Decode, 226, 4, 45, // Opcode: SUBW
/* 3608 */    MCD::OPC_FilterValue, 36, 9, 0, 0, // Skip to: 3622
/* 3613 */    MCD::OPC_CheckPredicate, 15, 82, 7, 0, // Skip to: 5492
/* 3618 */    MCD::OPC_Decode, 225, 4, 45, // Opcode: SUBUW
/* 3622 */    MCD::OPC_FilterValue, 37, 73, 7, 0, // Skip to: 5492
/* 3627 */    MCD::OPC_CheckPredicate, 15, 68, 7, 0, // Skip to: 5492
/* 3632 */    MCD::OPC_Decode, 227, 4, 45, // Opcode: SUBWU
/* 3636 */    MCD::OPC_FilterValue, 1, 144, 0, 0, // Skip to: 3785
/* 3641 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 3644 */    MCD::OPC_FilterValue, 0, 101, 0, 0, // Skip to: 3750
/* 3649 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 3652 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3666
/* 3657 */    MCD::OPC_CheckPredicate, 4, 38, 7, 0, // Skip to: 5492
/* 3662 */    MCD::OPC_Decode, 202, 4, 45, // Opcode: SLLW
/* 3666 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3680
/* 3671 */    MCD::OPC_CheckPredicate, 17, 24, 7, 0, // Skip to: 5492
/* 3676 */    MCD::OPC_Decode, 197, 4, 45, // Opcode: SHFLW
/* 3680 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3694
/* 3685 */    MCD::OPC_CheckPredicate, 15, 10, 7, 0, // Skip to: 5492
/* 3690 */    MCD::OPC_Decode, 206, 4, 45, // Opcode: SLOW
/* 3694 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3708
/* 3699 */    MCD::OPC_CheckPredicate, 16, 252, 6, 0, // Skip to: 5492
/* 3704 */    MCD::OPC_Decode, 181, 4, 45, // Opcode: SBSETW
/* 3708 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 3722
/* 3713 */    MCD::OPC_CheckPredicate, 16, 238, 6, 0, // Skip to: 5492
/* 3718 */    MCD::OPC_Decode, 170, 4, 45, // Opcode: SBCLRW
/* 3722 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 3736
/* 3727 */    MCD::OPC_CheckPredicate, 18, 224, 6, 0, // Skip to: 5492
/* 3732 */    MCD::OPC_Decode, 161, 4, 45, // Opcode: ROLW
/* 3736 */    MCD::OPC_FilterValue, 13, 215, 6, 0, // Skip to: 5492
/* 3741 */    MCD::OPC_CheckPredicate, 16, 210, 6, 0, // Skip to: 5492
/* 3746 */    MCD::OPC_Decode, 177, 4, 45, // Opcode: SBINVW
/* 3750 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 3771
/* 3755 */    MCD::OPC_CheckPredicate, 27, 196, 6, 0, // Skip to: 5492
/* 3760 */    MCD::OPC_CheckField, 27, 5, 1, 189, 6, 0, // Skip to: 5492
/* 3767 */    MCD::OPC_Decode, 210, 2, 45, // Opcode: CLMULW
/* 3771 */    MCD::OPC_FilterValue, 2, 180, 6, 0, // Skip to: 5492
/* 3776 */    MCD::OPC_CheckPredicate, 19, 175, 6, 0, // Skip to: 5492
/* 3781 */    MCD::OPC_Decode, 228, 3, 46, // Opcode: FSLW
/* 3785 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 3806
/* 3790 */    MCD::OPC_CheckPredicate, 27, 161, 6, 0, // Skip to: 5492
/* 3795 */    MCD::OPC_CheckField, 25, 7, 5, 154, 6, 0, // Skip to: 5492
/* 3802 */    MCD::OPC_Decode, 209, 2, 45, // Opcode: CLMULRW
/* 3806 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 3827
/* 3811 */    MCD::OPC_CheckPredicate, 27, 140, 6, 0, // Skip to: 5492
/* 3816 */    MCD::OPC_CheckField, 25, 7, 5, 133, 6, 0, // Skip to: 5492
/* 3823 */    MCD::OPC_Decode, 207, 2, 45, // Opcode: CLMULHW
/* 3827 */    MCD::OPC_FilterValue, 4, 45, 0, 0, // Skip to: 3877
/* 3832 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 3835 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3849
/* 3840 */    MCD::OPC_CheckPredicate, 26, 111, 6, 0, // Skip to: 5492
/* 3845 */    MCD::OPC_Decode, 164, 3, 45, // Opcode: DIVW
/* 3849 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3863
/* 3854 */    MCD::OPC_CheckPredicate, 18, 97, 6, 0, // Skip to: 5492
/* 3859 */    MCD::OPC_Decode, 153, 4, 45, // Opcode: PACKW
/* 3863 */    MCD::OPC_FilterValue, 36, 88, 6, 0, // Skip to: 5492
/* 3868 */    MCD::OPC_CheckPredicate, 18, 83, 6, 0, // Skip to: 5492
/* 3873 */    MCD::OPC_Decode, 152, 4, 45, // Opcode: PACKUW
/* 3877 */    MCD::OPC_FilterValue, 5, 158, 0, 0, // Skip to: 4040
/* 3882 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 3885 */    MCD::OPC_FilterValue, 0, 115, 0, 0, // Skip to: 4005
/* 3890 */    MCD::OPC_ExtractField, 27, 5,  // Inst{31-27} ...
/* 3893 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3907
/* 3898 */    MCD::OPC_CheckPredicate, 4, 53, 6, 0, // Skip to: 5492
/* 3903 */    MCD::OPC_Decode, 219, 4, 45, // Opcode: SRLW
/* 3907 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3921
/* 3912 */    MCD::OPC_CheckPredicate, 17, 39, 6, 0, // Skip to: 5492
/* 3917 */    MCD::OPC_Decode, 232, 4, 45, // Opcode: UNSHFLW
/* 3921 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3935
/* 3926 */    MCD::OPC_CheckPredicate, 15, 25, 6, 0, // Skip to: 5492
/* 3931 */    MCD::OPC_Decode, 223, 4, 45, // Opcode: SROW
/* 3935 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3949
/* 3940 */    MCD::OPC_CheckPredicate, 17, 11, 6, 0, // Skip to: 5492
/* 3945 */    MCD::OPC_Decode, 241, 3, 45, // Opcode: GORCW
/* 3949 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 3963
/* 3954 */    MCD::OPC_CheckPredicate, 4, 253, 5, 0, // Skip to: 5492
/* 3959 */    MCD::OPC_Decode, 214, 4, 45, // Opcode: SRAW
/* 3963 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 3977
/* 3968 */    MCD::OPC_CheckPredicate, 16, 239, 5, 0, // Skip to: 5492
/* 3973 */    MCD::OPC_Decode, 173, 4, 45, // Opcode: SBEXTW
/* 3977 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 3991
/* 3982 */    MCD::OPC_CheckPredicate, 18, 225, 5, 0, // Skip to: 5492
/* 3987 */    MCD::OPC_Decode, 165, 4, 45, // Opcode: RORW
/* 3991 */    MCD::OPC_FilterValue, 13, 216, 5, 0, // Skip to: 5492
/* 3996 */    MCD::OPC_CheckPredicate, 17, 211, 5, 0, // Skip to: 5492
/* 4001 */    MCD::OPC_Decode, 245, 3, 45, // Opcode: GREVW
/* 4005 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 4026
/* 4010 */    MCD::OPC_CheckPredicate, 26, 197, 5, 0, // Skip to: 5492
/* 4015 */    MCD::OPC_CheckField, 27, 5, 0, 190, 5, 0, // Skip to: 5492
/* 4022 */    MCD::OPC_Decode, 163, 3, 45, // Opcode: DIVUW
/* 4026 */    MCD::OPC_FilterValue, 2, 181, 5, 0, // Skip to: 5492
/* 4031 */    MCD::OPC_CheckPredicate, 19, 176, 5, 0, // Skip to: 5492
/* 4036 */    MCD::OPC_Decode, 234, 3, 46, // Opcode: FSRW
/* 4040 */    MCD::OPC_FilterValue, 6, 45, 0, 0, // Skip to: 4090
/* 4045 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 4048 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4062
/* 4053 */    MCD::OPC_CheckPredicate, 26, 154, 5, 0, // Skip to: 5492
/* 4058 */    MCD::OPC_Decode, 159, 4, 45, // Opcode: REMW
/* 4062 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4076
/* 4067 */    MCD::OPC_CheckPredicate, 28, 140, 5, 0, // Skip to: 5492
/* 4072 */    MCD::OPC_Decode, 194, 2, 45, // Opcode: BEXTW
/* 4076 */    MCD::OPC_FilterValue, 36, 131, 5, 0, // Skip to: 5492
/* 4081 */    MCD::OPC_CheckPredicate, 28, 126, 5, 0, // Skip to: 5492
/* 4086 */    MCD::OPC_Decode, 191, 2, 45, // Opcode: BDEPW
/* 4090 */    MCD::OPC_FilterValue, 7, 117, 5, 0, // Skip to: 5492
/* 4095 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 4098 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4112
/* 4103 */    MCD::OPC_CheckPredicate, 26, 104, 5, 0, // Skip to: 5492
/* 4108 */    MCD::OPC_Decode, 158, 4, 45, // Opcode: REMUW
/* 4112 */    MCD::OPC_FilterValue, 36, 95, 5, 0, // Skip to: 5492
/* 4117 */    MCD::OPC_CheckPredicate, 29, 90, 5, 0, // Skip to: 5492
/* 4122 */    MCD::OPC_Decode, 196, 2, 45, // Opcode: BFPW
/* 4126 */    MCD::OPC_FilterValue, 67, 31, 0, 0, // Skip to: 4162
/* 4131 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 4134 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4148
/* 4139 */    MCD::OPC_CheckPredicate, 5, 68, 5, 0, // Skip to: 5492
/* 4144 */    MCD::OPC_Decode, 203, 3, 47, // Opcode: FMADD_S
/* 4148 */    MCD::OPC_FilterValue, 1, 59, 5, 0, // Skip to: 5492
/* 4153 */    MCD::OPC_CheckPredicate, 6, 54, 5, 0, // Skip to: 5492
/* 4158 */    MCD::OPC_Decode, 202, 3, 48, // Opcode: FMADD_D
/* 4162 */    MCD::OPC_FilterValue, 71, 31, 0, 0, // Skip to: 4198
/* 4167 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 4170 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4184
/* 4175 */    MCD::OPC_CheckPredicate, 5, 32, 5, 0, // Skip to: 5492
/* 4180 */    MCD::OPC_Decode, 209, 3, 47, // Opcode: FMSUB_S
/* 4184 */    MCD::OPC_FilterValue, 1, 23, 5, 0, // Skip to: 5492
/* 4189 */    MCD::OPC_CheckPredicate, 6, 18, 5, 0, // Skip to: 5492
/* 4194 */    MCD::OPC_Decode, 208, 3, 48, // Opcode: FMSUB_D
/* 4198 */    MCD::OPC_FilterValue, 75, 31, 0, 0, // Skip to: 4234
/* 4203 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 4206 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4220
/* 4211 */    MCD::OPC_CheckPredicate, 5, 252, 4, 0, // Skip to: 5492
/* 4216 */    MCD::OPC_Decode, 219, 3, 47, // Opcode: FNMSUB_S
/* 4220 */    MCD::OPC_FilterValue, 1, 243, 4, 0, // Skip to: 5492
/* 4225 */    MCD::OPC_CheckPredicate, 6, 238, 4, 0, // Skip to: 5492
/* 4230 */    MCD::OPC_Decode, 218, 3, 48, // Opcode: FNMSUB_D
/* 4234 */    MCD::OPC_FilterValue, 79, 31, 0, 0, // Skip to: 4270
/* 4239 */    MCD::OPC_ExtractField, 25, 2,  // Inst{26-25} ...
/* 4242 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4256
/* 4247 */    MCD::OPC_CheckPredicate, 5, 216, 4, 0, // Skip to: 5492
/* 4252 */    MCD::OPC_Decode, 217, 3, 47, // Opcode: FNMADD_S
/* 4256 */    MCD::OPC_FilterValue, 1, 207, 4, 0, // Skip to: 5492
/* 4261 */    MCD::OPC_CheckPredicate, 6, 202, 4, 0, // Skip to: 5492
/* 4266 */    MCD::OPC_Decode, 216, 3, 48, // Opcode: FNMADD_D
/* 4270 */    MCD::OPC_FilterValue, 83, 136, 3, 0, // Skip to: 5179
/* 4275 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 4278 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4292
/* 4283 */    MCD::OPC_CheckPredicate, 5, 180, 4, 0, // Skip to: 5492
/* 4288 */    MCD::OPC_Decode, 168, 3, 49, // Opcode: FADD_S
/* 4292 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4306
/* 4297 */    MCD::OPC_CheckPredicate, 6, 166, 4, 0, // Skip to: 5492
/* 4302 */    MCD::OPC_Decode, 167, 3, 50, // Opcode: FADD_D
/* 4306 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4320
/* 4311 */    MCD::OPC_CheckPredicate, 5, 152, 4, 0, // Skip to: 5492
/* 4316 */    MCD::OPC_Decode, 236, 3, 49, // Opcode: FSUB_S
/* 4320 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4334
/* 4325 */    MCD::OPC_CheckPredicate, 6, 138, 4, 0, // Skip to: 5492
/* 4330 */    MCD::OPC_Decode, 235, 3, 50, // Opcode: FSUB_D
/* 4334 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 4348
/* 4339 */    MCD::OPC_CheckPredicate, 5, 124, 4, 0, // Skip to: 5492
/* 4344 */    MCD::OPC_Decode, 211, 3, 49, // Opcode: FMUL_S
/* 4348 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 4362
/* 4353 */    MCD::OPC_CheckPredicate, 6, 110, 4, 0, // Skip to: 5492
/* 4358 */    MCD::OPC_Decode, 210, 3, 50, // Opcode: FMUL_D
/* 4362 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 4376
/* 4367 */    MCD::OPC_CheckPredicate, 5, 96, 4, 0, // Skip to: 5492
/* 4372 */    MCD::OPC_Decode, 190, 3, 49, // Opcode: FDIV_S
/* 4376 */    MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 4390
/* 4381 */    MCD::OPC_CheckPredicate, 6, 82, 4, 0, // Skip to: 5492
/* 4386 */    MCD::OPC_Decode, 189, 3, 50, // Opcode: FDIV_D
/* 4390 */    MCD::OPC_FilterValue, 16, 45, 0, 0, // Skip to: 4440
/* 4395 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4398 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4412
/* 4403 */    MCD::OPC_CheckPredicate, 5, 60, 4, 0, // Skip to: 5492
/* 4408 */    MCD::OPC_Decode, 226, 3, 51, // Opcode: FSGNJ_S
/* 4412 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4426
/* 4417 */    MCD::OPC_CheckPredicate, 5, 46, 4, 0, // Skip to: 5492
/* 4422 */    MCD::OPC_Decode, 222, 3, 51, // Opcode: FSGNJN_S
/* 4426 */    MCD::OPC_FilterValue, 2, 37, 4, 0, // Skip to: 5492
/* 4431 */    MCD::OPC_CheckPredicate, 5, 32, 4, 0, // Skip to: 5492
/* 4436 */    MCD::OPC_Decode, 224, 3, 51, // Opcode: FSGNJX_S
/* 4440 */    MCD::OPC_FilterValue, 17, 45, 0, 0, // Skip to: 4490
/* 4445 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4448 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4462
/* 4453 */    MCD::OPC_CheckPredicate, 6, 10, 4, 0, // Skip to: 5492
/* 4458 */    MCD::OPC_Decode, 225, 3, 52, // Opcode: FSGNJ_D
/* 4462 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4476
/* 4467 */    MCD::OPC_CheckPredicate, 6, 252, 3, 0, // Skip to: 5492
/* 4472 */    MCD::OPC_Decode, 221, 3, 52, // Opcode: FSGNJN_D
/* 4476 */    MCD::OPC_FilterValue, 2, 243, 3, 0, // Skip to: 5492
/* 4481 */    MCD::OPC_CheckPredicate, 6, 238, 3, 0, // Skip to: 5492
/* 4486 */    MCD::OPC_Decode, 223, 3, 52, // Opcode: FSGNJX_D
/* 4490 */    MCD::OPC_FilterValue, 20, 31, 0, 0, // Skip to: 4526
/* 4495 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4498 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4512
/* 4503 */    MCD::OPC_CheckPredicate, 5, 216, 3, 0, // Skip to: 5492
/* 4508 */    MCD::OPC_Decode, 207, 3, 51, // Opcode: FMIN_S
/* 4512 */    MCD::OPC_FilterValue, 1, 207, 3, 0, // Skip to: 5492
/* 4517 */    MCD::OPC_CheckPredicate, 5, 202, 3, 0, // Skip to: 5492
/* 4522 */    MCD::OPC_Decode, 205, 3, 51, // Opcode: FMAX_S
/* 4526 */    MCD::OPC_FilterValue, 21, 31, 0, 0, // Skip to: 4562
/* 4531 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4534 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4548
/* 4539 */    MCD::OPC_CheckPredicate, 6, 180, 3, 0, // Skip to: 5492
/* 4544 */    MCD::OPC_Decode, 206, 3, 52, // Opcode: FMIN_D
/* 4548 */    MCD::OPC_FilterValue, 1, 171, 3, 0, // Skip to: 5492
/* 4553 */    MCD::OPC_CheckPredicate, 6, 166, 3, 0, // Skip to: 5492
/* 4558 */    MCD::OPC_Decode, 204, 3, 52, // Opcode: FMAX_D
/* 4562 */    MCD::OPC_FilterValue, 32, 16, 0, 0, // Skip to: 4583
/* 4567 */    MCD::OPC_CheckPredicate, 6, 152, 3, 0, // Skip to: 5492
/* 4572 */    MCD::OPC_CheckField, 20, 5, 1, 145, 3, 0, // Skip to: 5492
/* 4579 */    MCD::OPC_Decode, 180, 3, 53, // Opcode: FCVT_S_D
/* 4583 */    MCD::OPC_FilterValue, 33, 23, 0, 0, // Skip to: 4611
/* 4588 */    MCD::OPC_CheckPredicate, 6, 131, 3, 0, // Skip to: 5492
/* 4593 */    MCD::OPC_CheckField, 20, 5, 0, 124, 3, 0, // Skip to: 5492
/* 4600 */    MCD::OPC_CheckField, 12, 3, 0, 117, 3, 0, // Skip to: 5492
/* 4607 */    MCD::OPC_Decode, 173, 3, 54, // Opcode: FCVT_D_S
/* 4611 */    MCD::OPC_FilterValue, 44, 16, 0, 0, // Skip to: 4632
/* 4616 */    MCD::OPC_CheckPredicate, 5, 103, 3, 0, // Skip to: 5492
/* 4621 */    MCD::OPC_CheckField, 20, 5, 0, 96, 3, 0, // Skip to: 5492
/* 4628 */    MCD::OPC_Decode, 230, 3, 55, // Opcode: FSQRT_S
/* 4632 */    MCD::OPC_FilterValue, 45, 16, 0, 0, // Skip to: 4653
/* 4637 */    MCD::OPC_CheckPredicate, 6, 82, 3, 0, // Skip to: 5492
/* 4642 */    MCD::OPC_CheckField, 20, 5, 0, 75, 3, 0, // Skip to: 5492
/* 4649 */    MCD::OPC_Decode, 229, 3, 56, // Opcode: FSQRT_D
/* 4653 */    MCD::OPC_FilterValue, 80, 45, 0, 0, // Skip to: 4703
/* 4658 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4661 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4675
/* 4666 */    MCD::OPC_CheckPredicate, 5, 53, 3, 0, // Skip to: 5492
/* 4671 */    MCD::OPC_Decode, 198, 3, 57, // Opcode: FLE_S
/* 4675 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4689
/* 4680 */    MCD::OPC_CheckPredicate, 5, 39, 3, 0, // Skip to: 5492
/* 4685 */    MCD::OPC_Decode, 200, 3, 57, // Opcode: FLT_S
/* 4689 */    MCD::OPC_FilterValue, 2, 30, 3, 0, // Skip to: 5492
/* 4694 */    MCD::OPC_CheckPredicate, 5, 25, 3, 0, // Skip to: 5492
/* 4699 */    MCD::OPC_Decode, 195, 3, 57, // Opcode: FEQ_S
/* 4703 */    MCD::OPC_FilterValue, 81, 45, 0, 0, // Skip to: 4753
/* 4708 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 4711 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4725
/* 4716 */    MCD::OPC_CheckPredicate, 6, 3, 3, 0, // Skip to: 5492
/* 4721 */    MCD::OPC_Decode, 197, 3, 58, // Opcode: FLE_D
/* 4725 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4739
/* 4730 */    MCD::OPC_CheckPredicate, 6, 245, 2, 0, // Skip to: 5492
/* 4735 */    MCD::OPC_Decode, 199, 3, 58, // Opcode: FLT_D
/* 4739 */    MCD::OPC_FilterValue, 2, 236, 2, 0, // Skip to: 5492
/* 4744 */    MCD::OPC_CheckPredicate, 6, 231, 2, 0, // Skip to: 5492
/* 4749 */    MCD::OPC_Decode, 194, 3, 58, // Opcode: FEQ_D
/* 4753 */    MCD::OPC_FilterValue, 96, 59, 0, 0, // Skip to: 4817
/* 4758 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 4761 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4775
/* 4766 */    MCD::OPC_CheckPredicate, 5, 209, 2, 0, // Skip to: 5492
/* 4771 */    MCD::OPC_Decode, 188, 3, 59, // Opcode: FCVT_W_S
/* 4775 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4789
/* 4780 */    MCD::OPC_CheckPredicate, 5, 195, 2, 0, // Skip to: 5492
/* 4785 */    MCD::OPC_Decode, 186, 3, 59, // Opcode: FCVT_WU_S
/* 4789 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4803
/* 4794 */    MCD::OPC_CheckPredicate, 30, 181, 2, 0, // Skip to: 5492
/* 4799 */    MCD::OPC_Decode, 179, 3, 59, // Opcode: FCVT_L_S
/* 4803 */    MCD::OPC_FilterValue, 3, 172, 2, 0, // Skip to: 5492
/* 4808 */    MCD::OPC_CheckPredicate, 30, 167, 2, 0, // Skip to: 5492
/* 4813 */    MCD::OPC_Decode, 177, 3, 59, // Opcode: FCVT_LU_S
/* 4817 */    MCD::OPC_FilterValue, 97, 59, 0, 0, // Skip to: 4881
/* 4822 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 4825 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4839
/* 4830 */    MCD::OPC_CheckPredicate, 6, 145, 2, 0, // Skip to: 5492
/* 4835 */    MCD::OPC_Decode, 187, 3, 60, // Opcode: FCVT_W_D
/* 4839 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4853
/* 4844 */    MCD::OPC_CheckPredicate, 6, 131, 2, 0, // Skip to: 5492
/* 4849 */    MCD::OPC_Decode, 185, 3, 60, // Opcode: FCVT_WU_D
/* 4853 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4867
/* 4858 */    MCD::OPC_CheckPredicate, 31, 117, 2, 0, // Skip to: 5492
/* 4863 */    MCD::OPC_Decode, 178, 3, 60, // Opcode: FCVT_L_D
/* 4867 */    MCD::OPC_FilterValue, 3, 108, 2, 0, // Skip to: 5492
/* 4872 */    MCD::OPC_CheckPredicate, 31, 103, 2, 0, // Skip to: 5492
/* 4877 */    MCD::OPC_Decode, 176, 3, 60, // Opcode: FCVT_LU_D
/* 4881 */    MCD::OPC_FilterValue, 104, 59, 0, 0, // Skip to: 4945
/* 4886 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 4889 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4903
/* 4894 */    MCD::OPC_CheckPredicate, 5, 81, 2, 0, // Skip to: 5492
/* 4899 */    MCD::OPC_Decode, 183, 3, 61, // Opcode: FCVT_S_W
/* 4903 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4917
/* 4908 */    MCD::OPC_CheckPredicate, 5, 67, 2, 0, // Skip to: 5492
/* 4913 */    MCD::OPC_Decode, 184, 3, 61, // Opcode: FCVT_S_WU
/* 4917 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4931
/* 4922 */    MCD::OPC_CheckPredicate, 30, 53, 2, 0, // Skip to: 5492
/* 4927 */    MCD::OPC_Decode, 181, 3, 61, // Opcode: FCVT_S_L
/* 4931 */    MCD::OPC_FilterValue, 3, 44, 2, 0, // Skip to: 5492
/* 4936 */    MCD::OPC_CheckPredicate, 30, 39, 2, 0, // Skip to: 5492
/* 4941 */    MCD::OPC_Decode, 182, 3, 61, // Opcode: FCVT_S_LU
/* 4945 */    MCD::OPC_FilterValue, 105, 73, 0, 0, // Skip to: 5023
/* 4950 */    MCD::OPC_ExtractField, 20, 5,  // Inst{24-20} ...
/* 4953 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 4974
/* 4958 */    MCD::OPC_CheckPredicate, 6, 17, 2, 0, // Skip to: 5492
/* 4963 */    MCD::OPC_CheckField, 12, 3, 0, 10, 2, 0, // Skip to: 5492
/* 4970 */    MCD::OPC_Decode, 174, 3, 62, // Opcode: FCVT_D_W
/* 4974 */    MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 4995
/* 4979 */    MCD::OPC_CheckPredicate, 6, 252, 1, 0, // Skip to: 5492
/* 4984 */    MCD::OPC_CheckField, 12, 3, 0, 245, 1, 0, // Skip to: 5492
/* 4991 */    MCD::OPC_Decode, 175, 3, 62, // Opcode: FCVT_D_WU
/* 4995 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 5009
/* 5000 */    MCD::OPC_CheckPredicate, 31, 231, 1, 0, // Skip to: 5492
/* 5005 */    MCD::OPC_Decode, 171, 3, 63, // Opcode: FCVT_D_L
/* 5009 */    MCD::OPC_FilterValue, 3, 222, 1, 0, // Skip to: 5492
/* 5014 */    MCD::OPC_CheckPredicate, 31, 217, 1, 0, // Skip to: 5492
/* 5019 */    MCD::OPC_Decode, 172, 3, 63, // Opcode: FCVT_D_LU
/* 5023 */    MCD::OPC_FilterValue, 112, 45, 0, 0, // Skip to: 5073
/* 5028 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 5031 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 5052
/* 5036 */    MCD::OPC_CheckPredicate, 5, 195, 1, 0, // Skip to: 5492
/* 5041 */    MCD::OPC_CheckField, 20, 5, 0, 188, 1, 0, // Skip to: 5492
/* 5048 */    MCD::OPC_Decode, 215, 3, 64, // Opcode: FMV_X_W
/* 5052 */    MCD::OPC_FilterValue, 1, 179, 1, 0, // Skip to: 5492
/* 5057 */    MCD::OPC_CheckPredicate, 5, 174, 1, 0, // Skip to: 5492
/* 5062 */    MCD::OPC_CheckField, 20, 5, 0, 167, 1, 0, // Skip to: 5492
/* 5069 */    MCD::OPC_Decode, 170, 3, 64, // Opcode: FCLASS_S
/* 5073 */    MCD::OPC_FilterValue, 113, 45, 0, 0, // Skip to: 5123
/* 5078 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 5081 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 5102
/* 5086 */    MCD::OPC_CheckPredicate, 31, 145, 1, 0, // Skip to: 5492
/* 5091 */    MCD::OPC_CheckField, 20, 5, 0, 138, 1, 0, // Skip to: 5492
/* 5098 */    MCD::OPC_Decode, 214, 3, 65, // Opcode: FMV_X_D
/* 5102 */    MCD::OPC_FilterValue, 1, 129, 1, 0, // Skip to: 5492
/* 5107 */    MCD::OPC_CheckPredicate, 6, 124, 1, 0, // Skip to: 5492
/* 5112 */    MCD::OPC_CheckField, 20, 5, 0, 117, 1, 0, // Skip to: 5492
/* 5119 */    MCD::OPC_Decode, 169, 3, 65, // Opcode: FCLASS_D
/* 5123 */    MCD::OPC_FilterValue, 120, 23, 0, 0, // Skip to: 5151
/* 5128 */    MCD::OPC_CheckPredicate, 5, 103, 1, 0, // Skip to: 5492
/* 5133 */    MCD::OPC_CheckField, 20, 5, 0, 96, 1, 0, // Skip to: 5492
/* 5140 */    MCD::OPC_CheckField, 12, 3, 0, 89, 1, 0, // Skip to: 5492
/* 5147 */    MCD::OPC_Decode, 213, 3, 66, // Opcode: FMV_W_X
/* 5151 */    MCD::OPC_FilterValue, 121, 80, 1, 0, // Skip to: 5492
/* 5156 */    MCD::OPC_CheckPredicate, 31, 75, 1, 0, // Skip to: 5492
/* 5161 */    MCD::OPC_CheckField, 20, 5, 0, 68, 1, 0, // Skip to: 5492
/* 5168 */    MCD::OPC_CheckField, 12, 3, 0, 61, 1, 0, // Skip to: 5492
/* 5175 */    MCD::OPC_Decode, 212, 3, 62, // Opcode: FMV_D_X
/* 5179 */    MCD::OPC_FilterValue, 99, 57, 0, 0, // Skip to: 5241
/* 5184 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 5187 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5196
/* 5192 */    MCD::OPC_Decode, 192, 2, 67, // Opcode: BEQ
/* 5196 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5205
/* 5201 */    MCD::OPC_Decode, 204, 2, 67, // Opcode: BNE
/* 5205 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 5214
/* 5210 */    MCD::OPC_Decode, 199, 2, 67, // Opcode: BLT
/* 5214 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5223
/* 5219 */    MCD::OPC_Decode, 197, 2, 67, // Opcode: BGE
/* 5223 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5232
/* 5228 */    MCD::OPC_Decode, 200, 2, 67, // Opcode: BLTU
/* 5232 */    MCD::OPC_FilterValue, 7, 255, 0, 0, // Skip to: 5492
/* 5237 */    MCD::OPC_Decode, 198, 2, 67, // Opcode: BGEU
/* 5241 */    MCD::OPC_FilterValue, 103, 11, 0, 0, // Skip to: 5257
/* 5246 */    MCD::OPC_CheckField, 12, 3, 0, 239, 0, 0, // Skip to: 5492
/* 5253 */    MCD::OPC_Decode, 247, 3, 31, // Opcode: JALR
/* 5257 */    MCD::OPC_FilterValue, 111, 4, 0, 0, // Skip to: 5266
/* 5262 */    MCD::OPC_Decode, 246, 3, 68, // Opcode: JAL
/* 5266 */    MCD::OPC_FilterValue, 115, 221, 0, 0, // Skip to: 5492
/* 5271 */    MCD::OPC_ExtractField, 12, 3,  // Inst{14-12} ...
/* 5274 */    MCD::OPC_FilterValue, 0, 139, 0, 0, // Skip to: 5418
/* 5279 */    MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 5282 */    MCD::OPC_FilterValue, 0, 51, 0, 0, // Skip to: 5338
/* 5287 */    MCD::OPC_ExtractField, 15, 10,  // Inst{24-15} ...
/* 5290 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5306
/* 5295 */    MCD::OPC_CheckField, 7, 5, 0, 190, 0, 0, // Skip to: 5492
/* 5302 */    MCD::OPC_Decode, 166, 3, 0, // Opcode: ECALL
/* 5306 */    MCD::OPC_FilterValue, 32, 11, 0, 0, // Skip to: 5322
/* 5311 */    MCD::OPC_CheckField, 7, 5, 0, 174, 0, 0, // Skip to: 5492
/* 5318 */    MCD::OPC_Decode, 165, 3, 0, // Opcode: EBREAK
/* 5322 */    MCD::OPC_FilterValue, 64, 165, 0, 0, // Skip to: 5492
/* 5327 */    MCD::OPC_CheckField, 7, 5, 0, 158, 0, 0, // Skip to: 5492
/* 5334 */    MCD::OPC_Decode, 233, 4, 0, // Opcode: URET
/* 5338 */    MCD::OPC_FilterValue, 8, 36, 0, 0, // Skip to: 5379
/* 5343 */    MCD::OPC_ExtractField, 15, 10,  // Inst{24-15} ...
/* 5346 */    MCD::OPC_FilterValue, 64, 11, 0, 0, // Skip to: 5362
/* 5351 */    MCD::OPC_CheckField, 7, 5, 0, 134, 0, 0, // Skip to: 5492
/* 5358 */    MCD::OPC_Decode, 215, 4, 0, // Opcode: SRET
/* 5362 */    MCD::OPC_FilterValue, 160, 1, 124, 0, 0, // Skip to: 5492
/* 5368 */    MCD::OPC_CheckField, 7, 5, 0, 117, 0, 0, // Skip to: 5492
/* 5375 */    MCD::OPC_Decode, 234, 4, 0, // Opcode: WFI
/* 5379 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 5395
/* 5384 */    MCD::OPC_CheckField, 7, 5, 0, 101, 0, 0, // Skip to: 5492
/* 5391 */    MCD::OPC_Decode, 193, 4, 69, // Opcode: SFENCE_VMA
/* 5395 */    MCD::OPC_FilterValue, 24, 92, 0, 0, // Skip to: 5492
/* 5400 */    MCD::OPC_CheckField, 15, 10, 64, 85, 0, 0, // Skip to: 5492
/* 5407 */    MCD::OPC_CheckField, 7, 5, 0, 78, 0, 0, // Skip to: 5492
/* 5414 */    MCD::OPC_Decode, 140, 4, 0, // Opcode: MRET
/* 5418 */    MCD::OPC_FilterValue, 1, 24, 0, 0, // Skip to: 5447
/* 5423 */    MCD::OPC_CheckField, 15, 17, 128, 128, 6, 11, 0, 0, // Skip to: 5443
/* 5432 */    MCD::OPC_CheckField, 7, 5, 0, 4, 0, 0, // Skip to: 5443
/* 5439 */    MCD::OPC_Decode, 229, 4, 0, // Opcode: UNIMP
/* 5443 */    MCD::OPC_Decode, 227, 2, 70, // Opcode: CSRRW
/* 5447 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5456
/* 5452 */    MCD::OPC_Decode, 225, 2, 70, // Opcode: CSRRS
/* 5456 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 5465
/* 5461 */    MCD::OPC_Decode, 223, 2, 70, // Opcode: CSRRC
/* 5465 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 5474
/* 5470 */    MCD::OPC_Decode, 228, 2, 71, // Opcode: CSRRWI
/* 5474 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 5483
/* 5479 */    MCD::OPC_Decode, 226, 2, 71, // Opcode: CSRRSI
/* 5483 */    MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 5492
/* 5488 */    MCD::OPC_Decode, 224, 2, 71, // Opcode: CSRRCI
/* 5492 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableRISCV32Only_16[] = {
/* 0 */       MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 3 */       MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 39
/* 8 */       MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 11 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 25
/* 16 */      MCD::OPC_CheckPredicate, 32, 75, 0, 0, // Skip to: 96
/* 21 */      MCD::OPC_Decode, 248, 2, 72, // Opcode: C_FLW
/* 25 */      MCD::OPC_FilterValue, 7, 66, 0, 0, // Skip to: 96
/* 30 */      MCD::OPC_CheckPredicate, 32, 61, 0, 0, // Skip to: 96
/* 35 */      MCD::OPC_Decode, 252, 2, 72, // Opcode: C_FSW
/* 39 */      MCD::OPC_FilterValue, 1, 16, 0, 0, // Skip to: 60
/* 44 */      MCD::OPC_CheckPredicate, 33, 47, 0, 0, // Skip to: 96
/* 49 */      MCD::OPC_CheckField, 13, 3, 1, 40, 0, 0, // Skip to: 96
/* 56 */      MCD::OPC_Decode, 255, 2, 26, // Opcode: C_JAL
/* 60 */      MCD::OPC_FilterValue, 2, 31, 0, 0, // Skip to: 96
/* 65 */      MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 68 */      MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 82
/* 73 */      MCD::OPC_CheckPredicate, 32, 18, 0, 0, // Skip to: 96
/* 78 */      MCD::OPC_Decode, 249, 2, 73, // Opcode: C_FLWSP
/* 82 */      MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 96
/* 87 */      MCD::OPC_CheckPredicate, 32, 4, 0, 0, // Skip to: 96
/* 92 */      MCD::OPC_Decode, 253, 2, 74, // Opcode: C_FSWSP
/* 96 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableRVBC16[] = {
/* 0 */       MCD::OPC_ExtractField, 10, 6,  // Inst{15-10} ...
/* 3 */       MCD::OPC_FilterValue, 24, 16, 0, 0, // Skip to: 24
/* 8 */       MCD::OPC_CheckPredicate, 34, 53, 0, 0, // Skip to: 66
/* 13 */      MCD::OPC_CheckField, 0, 7, 1, 46, 0, 0, // Skip to: 66
/* 20 */      MCD::OPC_Decode, 143, 3, 17, // Opcode: C_NOT
/* 24 */      MCD::OPC_FilterValue, 25, 16, 0, 0, // Skip to: 45
/* 29 */      MCD::OPC_CheckPredicate, 34, 32, 0, 0, // Skip to: 66
/* 34 */      MCD::OPC_CheckField, 0, 7, 1, 25, 0, 0, // Skip to: 66
/* 41 */      MCD::OPC_Decode, 140, 3, 17, // Opcode: C_NEG
/* 45 */      MCD::OPC_FilterValue, 26, 16, 0, 0, // Skip to: 66
/* 50 */      MCD::OPC_CheckPredicate, 35, 11, 0, 0, // Skip to: 66
/* 55 */      MCD::OPC_CheckField, 0, 7, 1, 4, 0, 0, // Skip to: 66
/* 62 */      MCD::OPC_Decode, 160, 3, 17, // Opcode: C_ZEXTW
/* 66 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[RISCV::FeatureStdExtC]);
  case 1:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::FeatureRVCHints]);
  case 2:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::FeatureStdExtD]);
  case 3:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::Feature64Bit]);
  case 4:
    return (Bits[RISCV::Feature64Bit]);
  case 5:
    return (Bits[RISCV::FeatureStdExtF]);
  case 6:
    return (Bits[RISCV::FeatureStdExtD]);
  case 7:
    return (Bits[RISCV::FeatureExtZbp]);
  case 8:
    return (Bits[RISCV::FeatureExtZbb]);
  case 9:
    return (Bits[RISCV::FeatureExtZbs]);
  case 10:
    return (Bits[RISCV::FeatureExtZbm] && Bits[RISCV::Feature64Bit]);
  case 11:
    return (Bits[RISCV::FeatureExtZbr]);
  case 12:
    return (Bits[RISCV::FeatureExtZbr] && Bits[RISCV::Feature64Bit]);
  case 13:
    return ((Bits[RISCV::FeatureExtZbb] || Bits[RISCV::FeatureExtZbp]));
  case 14:
    return (Bits[RISCV::FeatureExtZbt]);
  case 15:
    return (Bits[RISCV::FeatureExtZbb] && Bits[RISCV::Feature64Bit]);
  case 16:
    return (Bits[RISCV::FeatureExtZbs] && Bits[RISCV::Feature64Bit]);
  case 17:
    return (Bits[RISCV::FeatureExtZbp] && Bits[RISCV::Feature64Bit]);
  case 18:
    return ((Bits[RISCV::FeatureExtZbb] || Bits[RISCV::FeatureExtZbp]) && Bits[RISCV::Feature64Bit]);
  case 19:
    return (Bits[RISCV::FeatureExtZbt] && Bits[RISCV::Feature64Bit]);
  case 20:
    return (Bits[RISCV::FeatureStdExtA]);
  case 21:
    return (Bits[RISCV::FeatureStdExtA] && Bits[RISCV::Feature64Bit]);
  case 22:
    return (Bits[RISCV::FeatureStdExtM]);
  case 23:
    return (Bits[RISCV::FeatureExtZbc]);
  case 24:
    return (Bits[RISCV::FeatureExtZbe]);
  case 25:
    return (Bits[RISCV::FeatureExtZbf]);
  case 26:
    return (Bits[RISCV::FeatureStdExtM] && Bits[RISCV::Feature64Bit]);
  case 27:
    return (Bits[RISCV::FeatureExtZbc] && Bits[RISCV::Feature64Bit]);
  case 28:
    return (Bits[RISCV::FeatureExtZbe] && Bits[RISCV::Feature64Bit]);
  case 29:
    return (Bits[RISCV::FeatureExtZbf] && Bits[RISCV::Feature64Bit]);
  case 30:
    return (Bits[RISCV::FeatureStdExtF] && Bits[RISCV::Feature64Bit]);
  case 31:
    return (Bits[RISCV::FeatureStdExtD] && Bits[RISCV::Feature64Bit]);
  case 32:
    return (Bits[RISCV::FeatureStdExtC] && Bits[RISCV::FeatureStdExtF] && !Bits[RISCV::Feature64Bit]);
  case 33:
    return (Bits[RISCV::FeatureStdExtC] && !Bits[RISCV::Feature64Bit]);
  case 34:
    return (Bits[RISCV::FeatureExtZbproposedc] && Bits[RISCV::FeatureStdExtC]);
  case 35:
    return (Bits[RISCV::FeatureExtZbproposedc] && (Bits[RISCV::FeatureExtZbb] || Bits[RISCV::FeatureExtZbp]) && Bits[RISCV::FeatureStdExtC] && Bits[RISCV::Feature64Bit]);
  }
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 3;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 7, 4) << 6;
    tmp |= fieldFromInstruction(insn, 11, 2) << 4;
    if (decodeUImmNonZeroOperand<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 2:
    if (decodeRVCInstrSImm(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 5:
    if (decodeRVCInstrRdRs1UImm(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeFPR64CRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 3) << 6;
    tmp |= fieldFromInstruction(insn, 5, 2) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<7>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    if (decodeRVCInstrRdSImm(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 2) << 6;
    tmp |= fieldFromInstruction(insn, 4, 3) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 5;
    tmp |= fieldFromInstruction(insn, 3, 2) << 7;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 4;
    tmp |= fieldFromInstruction(insn, 12, 1) << 9;
    if (decodeSImmNonZeroOperand<10>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0X2RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeCLUIImmOperand(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 3) << 6;
    tmp |= fieldFromInstruction(insn, 5, 2) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 5) << 0;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeSImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 22:
    if (decodeRVCInstrRdRs2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 24:
    if (decodeRVCInstrRdRs1Rs2(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRNoX0RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 4;
    tmp |= fieldFromInstruction(insn, 3, 3) << 0;
    tmp |= fieldFromInstruction(insn, 6, 1) << 6;
    tmp |= fieldFromInstruction(insn, 7, 1) << 5;
    tmp |= fieldFromInstruction(insn, 8, 1) << 9;
    tmp |= fieldFromInstruction(insn, 9, 2) << 7;
    tmp |= fieldFromInstruction(insn, 11, 1) << 3;
    tmp |= fieldFromInstruction(insn, 12, 1) << 10;
    if (decodeSImmOperandAndLsl1<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 3) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 1) << 4;
    tmp |= fieldFromInstruction(insn, 3, 2) << 0;
    tmp |= fieldFromInstruction(insn, 5, 2) << 5;
    tmp |= fieldFromInstruction(insn, 10, 2) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 7;
    if (decodeSImmOperandAndLsl1<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 2) << 6;
    tmp |= fieldFromInstruction(insn, 9, 4) << 2;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 3) << 6;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<9>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 24, 4);
    if (decodeUImmOperand<4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 4);
    if (decodeUImmOperand<4>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 6);
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 6);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 6);
    if (decodeUImmOperand<6>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 20);
    if (decodeUImmOperand<20>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 5) << 0;
    tmp |= fieldFromInstruction(insn, 25, 7) << 5;
    if (decodeSImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 27, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 12, 3);
    if (decodeFRMArg(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeFPR64RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 1) << 10;
    tmp |= fieldFromInstruction(insn, 8, 4) << 0;
    tmp |= fieldFromInstruction(insn, 25, 6) << 4;
    tmp |= fieldFromInstruction(insn, 31, 1) << 11;
    if (decodeSImmOperandAndLsl1<13>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 12, 8) << 11;
    tmp |= fieldFromInstruction(insn, 20, 1) << 10;
    tmp |= fieldFromInstruction(insn, 21, 10) << 0;
    tmp |= fieldFromInstruction(insn, 31, 1) << 19;
    if (decodeSImmOperandAndLsl1<21>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeUImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeGPRRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 20, 12);
    if (decodeUImmOperand<12>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (decodeUImmOperand<5>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 2, 3);
    if (DecodeFPR32CRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 7, 3);
    if (DecodeGPRCRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 5, 1) << 6;
    tmp |= fieldFromInstruction(insn, 6, 1) << 2;
    tmp |= fieldFromInstruction(insn, 10, 3) << 3;
    if (decodeUImmOperand<7>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 7, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 2, 2) << 6;
    tmp |= fieldFromInstruction(insn, 4, 3) << 2;
    tmp |= fieldFromInstruction(insn, 12, 1) << 5;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 2, 5);
    if (DecodeFPR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    tmp |= fieldFromInstruction(insn, 7, 2) << 6;
    tmp |= fieldFromInstruction(insn, 9, 4) << 2;
    if (decodeUImmOperand<8>(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  InsnType CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      InsnType ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
